#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

PROFILE=/flash/qvidium/decoder/profile

if [ "$QUERY_STRING" = "" ]; then

    OUTPUT=Network
    DISABLE_UDP_GENLOCK=false
    VIDEO_PAL_N=No
    TRANSPORT=UDP
    MULTICAST_IPADDR=
    UDP_PORT=10000
    NETWORK_JITTER=50
    VIDEO_BUFFER_SIZE=150
    OUT_OF_ORDER_SIZE=0
    DETECT_VIDEO_CHANGE=yes
    DETECT_VIDEO_MS=150
    RESPONSE=250
    BURST_DROP=40
    ROBUST=1
    NUM_RETRIES=2
    RT_TIME=100
    ARQ_MODE=Auto
    ARQ_PORT=7020
    PING_SENDER=0
    SERVER_IPADDR=
    ECHO_PORT=7

    [ -f $PROFILE ] && . $PROFILE

    HAS_SDI=false
    [ -f /flash/qvidium/inputs.conf ] && . /flash/qvidium/inputs.conf
    [ "$HAS_SDI" = "" ] && HAS_SDI=false

    [ "$OUT_OF_ORDER_SIZE"x = x ] && OUT_OF_ORDER_SIZE=0

    PAL_N_ON_Selected=
    PAL_N_OFF_Selected=
    case "$VIDEO_PAL_N" in 
        Yes) PAL_N_ON_Selected=selected ;;
        *) PAL_N_OFF_Selected=selected ;;
    esac

    UDP_GENLOCK_DISABLED_TRUE_SELECTED=
    UDP_GENLOCK_DISABLED_FALSE_SELECTED=
    if [ "$DISABLE_UDP_GENLOCK" = true ] ; then
        UDP_GENLOCK_DISABLED_TRUE_SELECTED=selected
    else
        UDP_GENLOCK_DISABLED_FALSE_SELECTED=selected
    fi

    PING0_CHECKED=
    PING1_CHECKED=
    if [ "$PING_SENDER" = 1 ] ; then
      PING1_CHECKED=checked
    else
      PING0_CHECKED=checked
    fi

    ENC_ARQ_Selected=
    ENC_RTP_Selected=
    ENC_UDP_Selected=
    if [ $TRANSPORT = RTP ] ; then
        ENC_RTP_Selected=selected
    elif [ $TRANSPORT = ARQ ] ; then
        ENC_ARQ_Selected=selected
    else
        ENC_UDP_Selected=selected
    fi

    [ "$DETECT_VIDEO_MS"x = x ] && DETECT_VIDEO_MS=150

    DETECT_VID_YES_Selected=
    DETECT_VID_NO_Selected=
    if [ "$DETECT_VIDEO_CHANGE" = yes ] ; then
        DETECT_VID_YES_Selected=selected
    else
        DETECT_VID_NO_Selected=selected
    fi

    robustcheck=
    [ "$ROBUST" = 1 ] && robustcheck=checked

    ARQ_AUTO_Selected=
    ARQ_MANUAL_Selected=
    if [ $ARQ_MODE = Manual ] ; then
        ARQ_MANUAL_Selected=selected
    else
        ARQ_AUTO_Selected=selected
    fi

    [ $HAS_SDI = false ] && OUTPUT=Network
    NET_OUT_Selected=
    ASI_OUT_Selected=
    if [ "$OUTPUT" = ASI ] ; then
        ASI_OUT_Selected=selected
    else
        NET_OUT_Selected=selected
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>Video Setup</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
  <link href="/tabbed_panel.css" type="text/css" rel="stylesheet">
  <SCRIPT LANGUAGE=JAVASCRIPT>

  function IsNumeric(str) {
    var ValidChars = "0123456789";
    var Char;

    for (i = 0; i < str.length; i++) {
      Char = str.charAt(i);
      if (ValidChars.indexOf(Char) == -1) return false;
    }
    return true;
  }

  function ManageTabPanelDisplay() {
    //
    // Between the parenthesis, list the id's of the div's that
    //     will be effected when tabs are clicked. List in any
    //     order. Put the id's in single quotes (apostrophes)
    //     and separate them with a comma -- all one line.
    //
    var idlist = new Array('tab2focus','tab3focus','tab4focus',
                           'tab2ready','tab3ready','tab4ready',
                           'content2','content3','content4');

    if (arguments.length < 1) { return; }
    for (var i = 0; i < idlist.length; i++) {
      var block = false;
      for (var ii = 0; ii < arguments.length; ii++) {
        if (idlist[i] == arguments[ii]) {
          block = true;
          break;
        }
      }
      if (block) {
        document.getElementById(idlist[i]).style.display = "block";
      }
      else {
        document.getElementById(idlist[i]).style.display = "none";
      }
    }
  }

  // whichTest = 0 means test uni-cast
  // whichTest = 1 means test multi-cast
  function verifyIP (IPvalue, whichTest) {
    errorString = "";
    theName = "IPaddress";

    var ipArray = IPvalue.match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);

    if (IPvalue == null || IPvalue == "") {
      return true;
    }

    if (IPvalue == "0.0.0.0")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    else if (IPvalue == "255.255.255.255")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    if (ipArray == null)
      errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
    else {
      for (i = 1; i < 5; i++) {
        thisSegment = ipArray[i];
        if (thisSegment > 255) {
          errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
          i = 5;
        }
        if (i == 1) {
          if (whichTest == 0) {
            if (thisSegment >= 224) {
              errorString = errorString + theName + ': '+IPvalue+' is not a valid uni-cast IP address.';
              i = 5;
            }
          }
          else if (whichTest == 1) {
            if ((thisSegment < 224) || (thisSegment > 239)) {
              errorString = errorString + theName + ': '+IPvalue+' is not a valid multicast address .';
              i = 5;
            }
          }
        }
      }
    }
    extensionLength = 3;
    if (errorString != "") {
      alert (errorString);
      return false;
    }
    return true;
  }

  function verify()
  {
    var mCastAddr = document.forms[0].MULTICAST_IPADDR.value;
    if (verifyIP(mCastAddr, 1) == false) return false;

    var tmp;
    var tmp2;

    tmp = document.forms[0].UDP_PORT.value;
    if (IsNumeric(tmp) == false || tmp < 1 || tmp > 65535) {
      alert('Source UDP Port "'+tmp+'" is not valid [1,65535].');
      return false;
    }
    tmp = document.forms[0].DETECT_VIDEO_MS.value;
    if (IsNumeric(tmp) == false || tmp < 100 || tmp > 10000) {
      alert('Detect Video Break "'+tmp+'" is not valid [100,10000].');
      return false;
    }
    tmp = document.forms[0].NETWORK_JITTER.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 3000) {
      alert('Jitter "'+tmp+'" is not valid [0,3000].');
      return false;
    }
    tmp = document.forms[0].OUT_OF_ORDER_SIZE.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 100) {
      alert('Out Of order "'+tmp+'" is not valid [0,100].');
      return false;
    }
    tmp = document.forms[0].RESPONSE.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 3000) {
      alert('Target Latency "'+tmp+'" is not valid [0,3000].');
      return false;
    }
    tmp2 = document.forms[0].BURST_DROP.value;
    if (IsNumeric(tmp2) == false || tmp2 < 0 || tmp2 > 1000) {
      alert('Burst drop "'+tmp2+'" is not valid [0,1000].');
      return false;
    }
    var a = new Number(tmp2);
    var b = new Number(tmp);
    if (a >= b) {
      alert('Burst drop "'+tmp2+'" must be less than Target Latency ('+tmp+').');
      return false;
    }
    tmp = document.forms[0].NUM_RETRIES.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 10) {
      alert('Number Retries "'+tmp+'" is not valid [0,10].');
      return false;
    }
    tmp = document.forms[0].RT_TIME.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 2000) {
      alert('Jitter "'+tmp+'" is not valid [0,2000].');
      return false;
    }
    tmp = document.forms[0].ECHO_PORT.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 65535) {
      alert('Echo Port "'+tmp+'" is not valid [0,65535].');
      return false;
    }
    tmp = document.forms[0].ARQ_PORT.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 65535) {
      alert('ARQ Port "'+tmp+'" is not valid [0,63353].');
      return false;
    }

    //var IPAddr = document.forms[0].SERVER_IPADDR.value;
    //if (verifyIP(IPAddr, 0) == false) return false;

    return true;
  }
  </SCRIPT>
</head>
<body>
 <h2><center>Decoder Profile</center></h2>
 <p>
 <b><a href="/DecoderProfile.html" target="_blank">Press here for Help</a></b>
 <p>
  <form name="video" method="get" action="decoder-setup.cgi" onSubmit="return verify()">

EOT
    if [ $HAS_SDI = true ] ; then
        cat << EOT
    <TABLE width=600 class=props cellSpacing="1" cellPadding="10" border="1">
     <TR>
      <TD width=100>
       <div style="font-size: 125%">
        Input
       </div>
      </TD>
      <TD>
       <SELECT name="OUTPUT">
        <OPTION $NET_OUT_Selected>Network</OPTION>
        <OPTION $ASI_OUT_Selected>ASI</OPTION>
       </SELECT>
      </TD>
     </TR>
    </TABLE>
    <br>

EOT
    fi

    cat << EOT
    <TABLE width=600 class=props cellSpacing="1" cellPadding="10" border="1">
     <TR>
      <TD width=100>
       <div style="font-size: 125%">
        Output
       </div>
      </TD>
      <TD>
       PAL-N Composite/S-Video
       <SELECT name="VIDEO_PAL_N">
        <OPTION $PAL_N_ON_Selected>Yes</OPTION>
        <OPTION $PAL_N_OFF_Selected>No</OPTION>
       </SELECT>
      </TD>
     </TR>
    </TABLE>
    <br>
    <table width=600 style="border-collapse:collapse;" border="0" cellpadding="0" cellspacing="0">
     <tr>
       <td>
         <div id="tab2focus" class="tab tabfocus" style="display:block;">
           Network
         </div>
         <div id="tab2ready" class="tab tabhold" style="display:none;">
           <span onclick="ManageTabPanelDisplay('tab2focus','tab3ready','tab4ready','content2')">Network</span>
         </div>
       </td>
       <td width="5"> </td>
       <td>
         <div id="tab3focus" class="tab tabfocus" style="display:none;">
           ARQ
         </div>
         <div id="tab3ready" class="tab tabhold" style="display:block;">
           <span onclick="ManageTabPanelDisplay('tab2ready','tab3focus','tab4ready','content3')">ARQ</span>
         </div>
       </td>
       <td width="5"> </td>
       <td>
         <div id="tab4focus" class="tab tabfocus" style="display:none;">
           Server
         </div>
         <div id="tab4ready" class="tab tabhold" style="display:block;">
           <span onclick="ManageTabPanelDisplay('tab2ready','tab3ready','tab4focus','content4')">Server</span>
         </div>
       </td>
       <td class="tabspace" width="30"> </td>
     </tr>
     <tr>
       <td colspan="10">

         <!--  Network Parameters -->
         <div id="content2" class="tabcontent" style="display:block;">
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr align="left">
             <td>IP Transport [1]</td>
             <td>
              <select name="TRANSPORT">
               <option $ENC_ARQ_Selected>ARQ</option>
               <option $ENC_RTP_Selected>RTP</option>
               <option $ENC_UDP_Selected>UDP</option>
              </select>
             </td>
            </tr>
            <tr align="left">
             <td>Multicast Address [2]</td>
             <td><input name="MULTICAST_IPADDR" size="16" maxlength="15" value="$MULTICAST_IPADDR" type="text"></td>
            </tr>
            <tr align="left">
             <td>UDP Port</td>
             <td><input name="UDP_PORT" size="16" maxlength="15" value="$UDP_PORT" type="text"></td>
            </tr>
            <tr align="left">
             <td>Jitter (ms)</td>
             <td><input name="NETWORK_JITTER" size="16" maxlength="15" value="$NETWORK_JITTER" type="text"></td>
            </tr>
            <tr align="left">
             <td>Video buffer size (ms)</td>
             <td><input name="VIDEO_BUFFER_SIZE" size="16" maxlength="15" value="$VIDEO_BUFFER_SIZE" type="text"></td>
            </tr>
            <tr align="left">
             <td>Out Of Order (#Packets) [3]</td>
             <td><input name="OUT_OF_ORDER_SIZE" size="16" maxlength="15" value="$OUT_OF_ORDER_SIZE" type="text"></td>
            </tr>
            <tr align="left">
             <td>Disable UDP Genlock (network input only)</td>
             <td>
              <select name="DISABLE_UDP_GENLOCK">
               <option $UDP_GENLOCK_DISABLED_TRUE_SELECTED>true</option>
               <option $UDP_GENLOCK_DISABLED_FALSE_SELECTED>false</option>
              </select>
             </td>
            </tr>
            <tr align="left">
             <td>Detect video break (network input only)</td>
             <td>
              <select name="DETECT_VIDEO_CHANGE">
               <option $DETECT_VID_YES_Selected>yes</option>
               <option $DETECT_VID_NO_Selected>no</option>
              </select>
             </td>
            <tr align="left">
             <td>Detect video break limit (100 to 10000 ms)</td>
             <td><input name="DETECT_VIDEO_MS" size="16" maxlength="15" value="$DETECT_VIDEO_MS" type="text"></td>
            </tr>
           </table>
           [1] If set to ARQ, the incoming bitrate must be less than 4Mbps.<br>
           [2] This is not the sender's IP address<br>
           [3] Normally set to 0. (Additional out of order buffering for ARQ and RTP only)
         </div>

         <!--  ARQ Parameters -->
         <div id="content3" class="tabcontent" style="display:none;">
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr align="left">
             <td>ARQ Port [1]</td>
             <td><input name="ARQ_PORT" size="16" maxlength="15" value="$ARQ_PORT" type="text"></td>
            </tr>
            <tr>
             <td>Mode</td>
             <td>
              <select name="ARQ_MODE">
               <option $ARQ_AUTO_Selected>Auto</option>
               <option $ARQ_MANUAL_Selected>Manual</option>
              </select>
             </td>
            </tr>
            <tr><td colSpan="2">Manual Mode Parameters</td></tr>
            <tr align="left">
             <td>Number Retries</td>
             <td><input name="NUM_RETRIES" size="16" maxlength="15" value="$NUM_RETRIES" type="text"></td>
            </tr>
            <tr align="left">
             <td>Round Trip Time</td>
             <td><input name="RT_TIME" size="16" maxlength="15" value="$RT_TIME" type="text"></td>
            </tr>
            <tr><td colSpan="2">Auto Mode Parameters</td></tr>
            <tr align="left">
             <td>Target Latency (ms)</td>
             <td><input name="RESPONSE" size="16" maxlength="15" value="$RESPONSE" type="text"></td>
            </tr>
            <tr align="left">
             <td>Max Burst Drop (ms) [2]</td>
             <td><input name="BURST_DROP" size="16" maxlength="15" value="$BURST_DROP" type="text"></td>
            </tr>
            <tr align="left">
             <td>Robust Mode</td>
             <td><input type="checkbox" name="ROBUST" value="1" $robustcheck ></td>
            </tr>
           </table>
           [1] Sends resend requests to receiver<br>
           [2] Burst Drop must be less than Target Latency
         </div>

         <!--  Server Parameters -->
         <div id="content4" class="tabcontent" style="display:none;">
           <strong><font size="+1">QVidium Video Server settings.</font></strong>
           <br>
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr>
              <td>Use Server</td>
              <td><input type=radio name="PING_SENDER" value="1" $PING1_CHECKED >Yes
                  <input type=radio name="PING_SENDER" value="0" $PING0_CHECKED >No
              </td>
            </tr>
            <tr>
              <td>IP Address or Hostname</td>
              <td><input name="SERVER_IPADDR" size="40" maxlength="39" value="$SERVER_IPADDR" type="text"></td>
            </tr>
            <tr>
              <td>Echo Port</td>
              <td><input name="ECHO_PORT" size="16" maxlength="15" value="$ECHO_PORT" type=test></td>
            </tr>
           </table>
            Note: Do not enable unless connecting to a QVidium video server.
         </div>

       </td>
     </tr>
   </table>

   <br>
   <input value="Save" type="submit">
 </form>
</body>
</html>
EOT

else
    eval `./cgiparse "$QUERY_STRING"`

    [ "$ROBUST" = "" ] && ROBUST=0

    msg="OK."

    cat << EOT > $PROFILE
OUTPUT=$OUTPUT
DISABLE_UDP_GENLOCK=$DISABLE_UDP_GENLOCK
VIDEO_PAL_N=$VIDEO_PAL_N
TRANSPORT=$TRANSPORT
MULTICAST_IPADDR=$MULTICAST_IPADDR
UDP_PORT=$UDP_PORT
NETWORK_JITTER=$NETWORK_JITTER
VIDEO_BUFFER_SIZE=$VIDEO_BUFFER_SIZE
OUT_OF_ORDER_SIZE=$OUT_OF_ORDER_SIZE
DETECT_VIDEO_CHANGE=$DETECT_VIDEO_CHANGE
DETECT_VIDEO_MS=$DETECT_VIDEO_MS
RESPONSE=$RESPONSE
BURST_DROP=$BURST_DROP
ROBUST=$ROBUST
NUM_RETRIES=$NUM_RETRIES
RT_TIME=$RT_TIME
ARQ_MODE=$ARQ_MODE
ARQ_PORT=$ARQ_PORT
PING_SENDER=$PING_SENDER
SERVER_IPADDR=$SERVER_IPADDR
ECHO_PORT=$ECHO_PORT
EOT

cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>Profile Status</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
</head>
<body>
 <h2><center>Profile Status</center></h2>
 $msg <br><br>Press the "Profile" option to update view.
</body>
</html>
EOT

fi
