#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

if [ "$QUERY_STRING" = "" ]; then

    tmp=`echo "$HTTP_REFERER" | sed 's/^.*?//'`
    eval `./cgiparse "$tmp"`
    case "$page" in
      *2) NUM=2 ;;
       *) NUM=  ;;
    esac

    CONF_FILE=/flash/qvidium/encoder/profile$NUM

    HAS_SDI=false
    [ -f /flash/qvidium/inputs.conf ] && . /flash/qvidium/inputs.conf
    [ "$HAS_SDI" = "" ] && HAS_SDI=false

    HAS_HD_RESIZE=false 
    HAS_HD_LICENSE=false 

    if [ $HAS_SDI = true ] ; then
        HasPermLic=0
        /qvidium/LicenseId HDEncode >/dev/null 2>&1
        if [ $? -lt 2 ] ; then # program is registered
            HasPermLic=1
            HAS_HD_LICENSE=true
        fi

        if [ $HasPermLic = 0 ] ; then
            /qvidium/LicenseId Digital > /dev/null 2>&1
            if [ $? -lt 2 ] ; then # program is registered
                HasPermLic=1
            fi
        fi
        if [ $HasPermLic = 0 ] ; then
            HAS_SDI=false
        else
            if [ -f /qvidium/firmware.ver ] ; then
                if grep 6.2.0.88 /qvidium/firmware.ver > /dev/null 2>&1 ; then
                    HAS_HD_RESIZE=true
                fi
            fi
        fi
    fi
 
    CLOSED_CAPTION=No
    LOW_DELAY=No
    BOND_PORTS=false
    LAN1_PERCENT=50
    STREAM_TYPE=Transport
    TS_BITRATE=6500000
    PROFILE=auto
    LEVEL=auto
    NUM_B_FRAMES=auto
    NUM_P_FRAMES=auto
    VIDEO_PID=256
    AUDIO_PID=272
    PCR_PID=$VIDEO_PID
    PMT_PID=48
    VIDEO_BITRATE=6000000
    AUDIO_BITRATE=192000
    AUDIO_SAMPLE_RATE=48000
    AUDIO_ENCODING="MPEG4 AAC"
    VIDEO_ENCODING=H264
    VIDEO_INPUT=Composite
    VIDEO_FILTER=On
    ENCODER_ACTION=Restart
    VIDEO_PAL_N=No
    SHARPNESS=Default
    VIDEO_SD_RES=Full
    RESYNC_SDI=Yes
    RESYNC_HDMI=Yes
    ANALOG_HDVIDEO=No
    AUDIO_CHANNELS=2
    FRAME_RATE=Full
    VIDEO_ASPECT=4x3
    OUTPUT=Network
    TRANSPORT=ARQ
    IPADDR_OR_HOSTNAME=
    UDP_PORT=10000
    NUM_TS_PKTS_PER_IP_PKT=7
    USE_PACING=0
    UNI_TTL=128
    M_TTL=64
    TOS=0
    ARQ_TX_BUFS=1024
    ARQ_PORT=7020
    DO_METADATA=0
    METADATA_PORT=4096

    FOR_SD=' (for SD)'
    if [ $HAS_SDI = false ] ; then
        FOR_SD=
        TS_BITRATE=2500000
        VIDEO_BITRATE=2000000
    fi
    [ $HAS_HD_RESIZE = true ] && FOR_SD=

    [ -f $CONF_FILE ] && . $CONF_FILE
    
    if [ $HAS_SDI = false ] ; then
        [ "$TS_BITRATE" = "" ] && TS_BITRATE=2500000
        [ "$VIDEO_BITRATE" = "" ] && VIDEO_BITRATE=2000000
        [ "$VIDEO_INPUT" = HDMI ] && VIDEO_INPUT=Composite
        [ "$VIDEO_INPUT" = SDI ] && VIDEO_INPUT=Composite
        [ "$VIDEO_INPUT" = "" ] && VIDEO_INPUT=Composite
    else
        [ "$TS_BITRATE" = "" ] && TS_BITRATE=6500000
        [ "$VIDEO_BITRATE" = "" ] && VIDEO_BITRATE=6000000
    fi
    [ "$UDP_PORT" = "" ] && UDP_PORT=10000
    [ "$ARQ_PORT" = "" ] && ARQ_PORT=7020
    [ "$NUM_TS_PKTS_PER_IP_PKT" = "" ] && NUM_TS_PKTS_PER_IP_PKT=7
    [ "$UNI_TTL" = "" ] && UNI_TTL=128
    [ "$M_TTL" = "" ] && M_TTL=64
    [ "$METADATA_PORT" = "" ] && METADATA_PORT=4096
    [ "$OUTPUT" = "" ] && OUTPUT=Network
    [ "$VIDEO_PID" = "" ] && VIDEO_PID=256
    [ "$AUDIO_PID" = "" ] && AUDIO_PID=272
    [ "$PCR_PID" = "" ] && PCR_PID=$VIDEO_PID
    [ "$PMT_PID" = "" ] && PMT_PID=48
    [ "$NUM_P_FRAMES" = "" ] && NUM_P_FRAMES=auto
    [ "$NUM_B_FRAMES" = "" ] && NUM_B_FRAMES=auto
    [ "$LAN1_PERCENT" = "" ] && LAN1_PERCENT=50
    [ "$ARQ_TX_BUFS" = "" ] && ARQ_TX_BUFS=1024

    EncAction_None_Selected=
    EncAction_Reboot_Selected=
    EncAction_Restart_Selected=
    case "$ENCODER_ACTION" in
        None) EncAction_None_Selected=selected ;;
        Reboot) EncAction_Reboot_Selected=selected ;;
        *) EncAction_Restart_Selected=selected ;;
    esac

    PAL_N_ON_Selected=
    PAL_N_OFF_Selected=
    case "$VIDEO_PAL_N" in 
        Yes) PAL_N_ON_Selected=selected ;;
        *) PAL_N_OFF_Selected=selected ;;
    esac

    ARQ_TX_BUFS_1024_Selected=
    ARQ_TX_BUFS_2048_Selected=
    ARQ_TX_BUFS_4096_Selected=
    case "$ARQ_TX_BUFS" in
        2048) ARQ_TX_BUFS_2048_Selected=selected ;;
        4096) ARQ_TX_BUFS_4096_Selected=selected ;;
        *) ARQ_TX_BUFS_1024_Selected=selected ;;
    esac

    BOND_TRUE_CHECKED= 
    BOND_FALSE_CHECKED= 
    case "$BOND_PORTS" in
        true) BOND_TRUE_CHECKED=checked ;;
        *) BOND_FALSE_CHECKED=checked ;;
    esac

    PACING0_CHECKED=
    PACING1_CHECKED=
    case "$USE_PACING" in
        1) PACING1_CHECKED=checked ;;
        *) PACING0_CHECKED=checked ;;
    esac

    P_FRAME_0_Selected=
    P_FRAME_1_Selected=
    P_FRAME_2_Selected=
    P_FRAME_3_Selected=
    P_FRAME_4_Selected=
    P_FRAME_5_Selected=
    P_FRAME_9_Selected=
    P_FRAME_14_Selected=
    P_FRAME_29_Selected=
    P_FRAME_A_Selected=
    case "$NUM_P_FRAMES" in
        0) P_FRAME_0_Selected=selected ;;
        1) P_FRAME_1_Selected=selected ;;
        2) P_FRAME_2_Selected=selected ;;
        3) P_FRAME_3_Selected=selected ;;
        4) P_FRAME_4_Selected=selected ;;
        5) P_FRAME_5_Selected=selected ;;
        9) P_FRAME_9_Selected=selected ;;
        14) P_FRAME_14_Selected=selected ;;
        29) P_FRAME_29_Selected=selected ;;
        *) P_FRAME_A_Selected=selected ;;
    esac
    
    B_FRAME_0_Selected=
    B_FRAME_1_Selected=
    B_FRAME_2_Selected=
    B_FRAME_A_Selected=
    case "$NUM_B_FRAMES" in
        0) B_FRAME_0_Selected=selected ;;
        1) B_FRAME_1_Selected=selected ;;
        2) B_FRAME_2_Selected=selected ;;
        *) B_FRAME_A_Selected=selected ;;
    esac

    PROFILE_B_Selected=
    PROFILE_M_Selected=
    PROFILE_H_Selected=
    PROFILE_A_Selected=
    case "$PROFILE" in
        Base) PROFILE_B_Selected=selected ;;
        Main) PROFILE_M_Selected=selected ;;
        High) PROFILE_H_Selected=selected ;;
           *) PROFILE_A_Selected=selected ;;
    esac

    LEVEL_12_Selected=
    LEVEL_20_Selected=
    LEVEL_21_Selected=
    LEVEL_22_Selected=
    LEVEL_30_Selected=
    LEVEL_31_Selected=
    LEVEL_32_Selected=
    LEVEL_40_Selected=
    LEVEL_41_Selected=
    LEVEL_A_Selected=
    case "$LEVEL" in
        1.2) LEVEL_12_Selected=selected ;;
        2.0) LEVEL_20_Selected=selected ;;
        2.1) LEVEL_21_Selected=selected ;;
        2.2) LEVEL_22_Selected=selected ;;
        3.0) LEVEL_30_Selected=selected ;;
        3.1) LEVEL_31_Selected=selected ;;
        3.2) LEVEL_32_Selected=selected ;;
        4.0) LEVEL_40_Selected=selected ;;
        4.1) LEVEL_41_Selected=selected ;;
          *) LEVEL_A_Selected=selected ;;
    esac

    if [ $HAS_HD_RESIZE = false ] ; then
        [ "$VIDEO_SD_RES" = D1 ] && VIDEO_SD_RES=Full
    fi
    VID_default_Selected=
    VID_D1_Selected=
    VID_CIF_Selected=
    VID_HALF_D1_Selected=
    case "$VIDEO_SD_RES" in 
        352x240) VID_CIF_Selected=selected ;;
        352x288) VID_CIF_Selected=selected ;;
        CIF) VID_CIF_Selected=selected ;;
        Half) VID_HALF_D1_Selected=selected ;;
        D1) VID_D1_Selected=selected ;;
        *) VID_default_Selected=selected ;;
    esac

    FR_Third_Selected=
    FR_Half_Selected=
    FR_Full_Selected=
    case "$FRAME_RATE" in 
        Third) FR_Third_Selected=selected ;;
        Half) FR_Half_Selected=selected ;;
        *) FR_Full_Selected=selected ;;
    esac

    MP4_Selected=
    TS_Selected=
    case "$STREAM_TYPE" in 
        MP4) MP4_Selected=selected ;;
        *) TS_Selected=selected ;;
    esac

    VID_FLT_ON_Selected=
    VID_FLT_OFF_Selected=
    case "$VIDEO_FILTER" in 
        On) VID_FLT_ON_Selected=selected ;;
        *) VID_FLT_OFF_Selected=selected ;;
    esac

    SHARPNESS_DFLT_Selected=
    SHARPNESS_SMOOTH_Selected=
    SHARPNESS_MEDIUM_Selected=
    SHARPNESS_SHARP_Selected=
    case "$SHARPNESS" in 
        smooth) SHARPNESS_SMOOTH_Selected=selected ;;
        medium) SHARPNESS_MEDIUM_Selected=selected ;;
        sharp) SHARPNESS_SHARP_Selected=selected ;;
        *) SHARPNESS_DFLT_Selected=selected ;;
    esac

    LOW_DELAY_ON_Selected=
    LOW_DELAY_OFF_Selected=
    case "$LOW_DELAY" in 
        Yes) LOW_DELAY_ON_Selected=selected ;;
        *) LOW_DELAY_OFF_Selected=selected ;;
    esac

    CLOSED_CAPTION_ON_Selected=
    CLOSED_CAPTION_OFF_Selected=
    case "$CLOSED_CAPTION" in 
        Yes) CLOSED_CAPTION_ON_Selected=selected ;;
        *) CLOSED_CAPTION_OFF_Selected=selected ;;
    esac

    ANALOG_HDVIDEO_ON_Selected=
    ANALOG_HDVIDEO_OFF_Selected=
    case "$ANALOG_HDVIDEO" in 
        Yes) ANALOG_HDVIDEO_ON_Selected=selected ;;
        *) ANALOG_HDVIDEO_OFF_Selected=selected ;;
    esac

    RESYNC_SDI_ON_Selected=
    RESYNC_SDI_OFF_Selected=
    case "$RESYNC_SDI" in 
        Yes) RESYNC_SDI_ON_Selected=selected ;;
        *) RESYNC_SDI_OFF_Selected=selected ;;
    esac

    RESYNC_HDMI_ON_Selected=
    RESYNC_HDMI_OFF_Selected=
    case "$RESYNC_HDMI" in 
        Yes) RESYNC_HDMI_ON_Selected=selected ;;
        *) RESYNC_HDMI_OFF_Selected=selected ;;
    esac

    OUT_ASI_Selected=
    OUT_NET_Selected=
    case "$OUTPUT" in 
        ASI) OUT_ASI_Selected=selected ;;
        *) OUT_NET_Selected=selected ;;
    esac

    AUDIO_CHANNELS_1_Selected=
    AUDIO_CHANNELS_2_Selected=
    case "$AUDIO_CHANNELS" in 
        1) AUDIO_CHANNELS_1_Selected=selected ;;
        *) AUDIO_CHANNELS_2_Selected=selected ;;
    esac

    AU_OFF_Selected=
    AU_32K_Selected=
    AU_56K_Selected=
    AU_64K_Selected=
    AU_96K_Selected=
    AU_112K_Selected=
    AU_128K_Selected=
    AU_160K_Selected=
    AU_192K_Selected=
    AU_224K_Selected=
    AU_256K_Selected=
    AU_320K_Selected=
    AU_384K_Selected=
    case "$AUDIO_BITRATE" in 
        #0) AU_OFF_Selected=selected ;;
        16000) AU_16K_Selected=selected ;;
        32000) AU_32K_Selected=selected ;;
        56000) AU_56K_Selected=selected ;;
        64000) AU_64K_Selected=selected ;;
        96000) AU_96K_Selected=selected ;;
        112000) AU_112K_Selected=selected ;;
        128000) AU_128K_Selected=selected ;;
        160000) AU_160K_Selected=selected ;;
        192000) AU_192K_Selected=selected ;;
        224000) AU_224K_Selected=selected ;;
        320000) AU_320K_Selected=selected ;;
        384000) AU_384K_Selected=selected ;;
        *) AU_256K_Selected=selected ;;
    esac

    AU_16Hz_Selected=
    AU_24Hz_Selected=
    AU_32Hz_Selected=
    AU_44Hz_Selected=
    AU_48Hz_Selected=
    case "$AUDIO_SAMPLE_RATE" in
        16000) AU_16Hz_Selected=selected ;;
        #24000) AU_24Hz_Selected=selected ;;
        32000) AU_32Hz_Selected=selected ;;
        44100) AU_44Hz_Selected=selected ;;
        *) AU_48Hz_Selected=selected ;;
    esac

    MPEG2_Selected=
    MPEG4_Selected=
    H264_Selected=
    MPEG2_CBR_Selected=
    H264_CBR_Selected=
    case "$VIDEO_ENCODING" in
        MPEG2) MPEG2_Selected=selected ;;
        #MPEG4) MPEG4_Selected=selected ;;
        MPEG2*C*) MPEG2_CBR_Selected=selected ;;
        H264*C*) H264_CBR_Selected=selected ;;
        *) H264_Selected=selected ;;
    esac
    
    AUD_MPEG4_Selected=
    AUD_MPEG2_Selected=
    AUD_MPEG1_Selected=
    case "$AUDIO_ENCODING" in
        MPEG1*) AUD_MPEG1_Selected=selected ;;
        MPEG2*) AUD_MPEG2_Selected=selected ;;
        *) AUD_MPEG4_Selected=selected ;;
    esac

    VID_COM_Selected=
    VID_SVID_Selected=
    VID_HDMI_Selected=
    VID_SDI_Selected=
    case "$VIDEO_INPUT" in
        HDMI) VID_HDMI_Selected=selected ;;
        S-Video) VID_SVID_Selected=selected ;;
        SDI) VID_SDI_Selected=selected ;;
        *) VID_COM_Selected=selected ;;
    esac

    VID_4x3_Selected=
    VID_16x9_Selected=
    case "$VIDEO_ASPECT" in
        16x9) VID_16x9_Selected=selected ;;
        *) VID_4x3_Selected=selected ;;
    esac

    ENC_ARQ_Selected=
    ENC_RTP_Selected=
    ENC_UDP_Selected=
    ENC_RTSP_Selected=
    case "$TRANSPORT" in
        #RTSP) ENC_RTSP_Selected=selected ;;
        RTP) ENC_RTP_Selected=selected ;;
        ARQ) ENC_ARQ_Selected=selected ;;
        *) ENC_UDP_Selected=selected ;;
    esac

    METADATA1_CHECKED=
    METADATA0_CHECKED=
    case "$DO_METADATA" in
        1) METADATA1_CHECKED=checked ;;
        *) METADATA0_CHECKED=checked ;;
    esac

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>Video Setup</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
  <link href="/tabbed_panel.css" type="text/css" rel="stylesheet">
  <SCRIPT LANGUAGE=JAVASCRIPT>

  function IsNumeric(str) {
    var ValidChars = "0123456789";
    var Char;

    for (i = 0; i < str.length; i++) {
      Char = str.charAt(i);
      if (ValidChars.indexOf(Char) == -1) return false;
    }
    return true;
  }

  function verifyIP (IPvalue) {
    errorString = "";
    theName = "IPaddress";

    var ipArray = IPvalue.match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);

    if (IPvalue == "0.0.0.0")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    else if (IPvalue == "255.255.255.255")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    if (ipArray == null)
      errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
    else {
      for (i = 1; i < 5; i++) {
        thisSegment = ipArray[i];
        if (thisSegment > 255) {
          errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
          i = 5;
        }
      }
    }
    extensionLength = 3;
    if (errorString != "") {
      alert (errorString);
      return false;
    }
    return true;
  }

  function ManageTabPanelDisplay() {
    //
    // Between the parenthesis, list the id's of the div's that
    //     will be effected when tabs are clicked. List in any
    //     order. Put the id's in single quotes (apostrophes)
    //     and separate them with a comma -- all one line.
    //
    var idlist = new Array('tab1focus','tab2focus',
                           'tab1ready','tab2ready',
                           'content1','content2');

    if (arguments.length < 1) { return; }
    for (var i = 0; i < idlist.length; i++) {
      var block = false;
      for (var ii = 0; ii < arguments.length; ii++) {
        if (idlist[i] == arguments[ii]) {
          block = true;
          break;
        }
      }
      if (block) {
        document.getElementById(idlist[i]).style.display = "block";
      }
      else {
        document.getElementById(idlist[i]).style.display = "none";
      }
    }
  }
 
  function verify()
  {
    var ipaddr = document.video.IPADDR_OR_HOSTNAME.value;

    //if (ipaddr.length > 0 && verifyIP(ipaddr) == false)
    //{
        //return false;
    //}

    return true;
  }
  
  function xx()
  {
       return DISABLED
  }
 
  function verifyBond()
  {
    var bond = document.video.BOND_PORTS.value;

    if (bond == false)
    {
        document.video.LAN1_PERCENT.disabled = true;
    }
    else
    {
        document.video.LAN1_PERCENT.disabled = false;
    }
    return true;
  }
  </SCRIPT>
</head>
<body>
 <h2><center>Encoder $NUM Profile</center></h2>
 <p>
 <b><a href="/EncoderProfile.html" target="_blank">Press here for Help</a></b>
 <p>
  <form name="video" method="get" action="encoder-setup.cgi" onSubmit="return verify()">
  <input id="CONF_FILE" type="hidden" name="CONF_FILE" value="$CONF_FILE">
  <table width=600 style="border-collapse:collapse;" border="0" cellpadding="0" cellspacing="0">
   <tr>
    <td>
     <div id="tab1focus" class="tab tabfocus" style="display:block;">
      Basic
     </div>
     <div id="tab1ready" class="tab tabhold" style="display:none;">
      <span onclick="ManageTabPanelDisplay('tab1focus','tab2ready','content1')">Basic</span>
     </div>
    </td>
    <td width="5"> </td>                                                                                                 
    <td>
     <div id="tab2focus" class="tab tabfocus" style="display:none;">
      Advanced
     </div>
     <div id="tab2ready" class="tab tabhold" style="display:block;">
      <span onclick="ManageTabPanelDisplay('tab1ready','tab2focus','content2')">Advanced</span>
     </div>
    </td>
    <td class="tabspace" width="30"> </td>                                                                               
   </tr>
   <tr>
    <td colspan="10">

     <!-- Basic Parameters -->
     <div id="content1" class="tabcontent" style="display:block;">

      <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=center>
	   <td colSpan="2" nowrap><strong><font size="4">Encoding</font></strong></td>
	   </tr>
       <tr>
        <td>Video Input</td>
        <td>
         <select name="VIDEO_INPUT">
          <option $VID_COM_Selected>Composite</option>
          <option $VID_SVID_Selected>S-Video</option>
EOT
    if [ $HAS_SDI != false ] ; then
        echo "          <option $VID_HDMI_Selected>HDMI</option>"
        echo "          <option $VID_SDI_Selected>SDI</option>"
    fi
    cat << EOT
         </select>
        </td>
       </tr>
       <tr align="left">
        <td>Video Bit Rate</td>
        <td><input name="VIDEO_BITRATE" size="8" maxlength="8" value="$VIDEO_BITRATE" type="text"></td>
       </tr>
       <tr>
        <td>Video Encoding</td>
        <td>
         <select name="VIDEO_ENCODING">
           <option $H264_Selected>H264</option>
           <option $MPEG2_Selected>MPEG2</option>
           <option $H264_CBR_Selected>H264 Constant Quantization</option>
           <option $MPEG2_CBR_Selected>MPEG2 Constant Quantization</option>
         <!--
           <option $MPEG4_Selected>MPEG4</option>
         -->
         </select>
        </td>
       </tr>
       <tr>
        <td>Audio Bit Rate</td>
        <td>
         <select name="AUDIO_BITRATE">
<!--
          <option $AU_OFF_Selected>0</option>
-->
          <option $AU_16K_Selected>16000</option>
          <option $AU_32K_Selected>32000</option>
          <option $AU_56K_Selected>56000</option>
          <option $AU_64K_Selected>64000</option>
          <option $AU_96K_Selected>96000</option>
          <option $AU_112K_Selected>112000</option>
          <option $AU_128K_Selected>128000</option>
          <option $AU_160K_Selected>160000</option>
          <option $AU_192K_Selected>192000</option>
          <option $AU_224K_Selected>224000</option>
          <option $AU_256K_Selected>256000</option>
          <option $AU_320K_Selected>320000</option>
          <option $AU_384K_Selected>384000</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Audio Encoding</td>
        <td>
         <select name="AUDIO_ENCODING">
          <option $AUD_MPEG4_Selected>MPEG4 AAC</option>
          <option $AUD_MPEG2_Selected>MPEG2 AAC</option>
          <option $AUD_MPEG1_Selected>MPEG1 Layer2</option>
         </select>
        </td>
       </tr>
       <tr>
EOT
    if [ $HAS_SDI != false ] ; then
        cat << EOT
        <td>Audio Sampling Rate<br>(for Composite and S-Video input)</td>
EOT
    else
        cat << EOT
        <td>Audio Sampling Rate</td>
EOT
    fi
    cat << EOT
        <td>
         <select name="AUDIO_SAMPLE_RATE">
          <option $AU_16Hz_Selected>16000</option>
<!--
          <option $AU_24Hz_Selected>24000</option>
-->
          <option $AU_32Hz_Selected>32000</option>
          <option $AU_44Hz_Selected>44100</option>
          <option $AU_48Hz_Selected>48000</option>
         </select>
        </td>
       </tr>
EOT
    if [ $HAS_SDI != false ] ; then
        cat << EOT
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">Output</font></strong></td></tr>
       <tr>
        <td>Device</td>
        <td>
         <select name="OUTPUT">
          <option $OUT_NET_Selected>Network</option>
          <option $OUT_ASI_Selected>ASI</option>
         </select>
        </td>
       </tr>
EOT
    fi
    cat << EOT
      
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">Network</font></strong></td></tr>
       <tr>
        <td>IP Transport</td>
        <td>
         <select name="TRANSPORT">
          <option $ENC_ARQ_Selected>ARQ</option>
          <option $ENC_RTP_Selected>RTP</option>
          <!-- 
          <option $ENC_RTSP_Selected>RTSP</option>
          -->
          <option $ENC_UDP_Selected>UDP</option>
         </select>
        </td>
       </tr>
       <tr align="left">
        <td>Destination IP or Multicast Address</td>
        <td><input name="IPADDR_OR_HOSTNAME" size="40" maxlength="39" value="$IPADDR_OR_HOSTNAME" type="text"></td>
       </tr>
       <tr align="left">
        <td>UDP Port</td>
        <td><input name="UDP_PORT" size="16" maxlength="15" value="$UDP_PORT" type="text"></td>
       </tr>
       <tr align="left">
        <td>ARQ Port</td>
        <td><input name="ARQ_PORT" size="16" maxlength="15" value="$ARQ_PORT" type="text"></td>
       </tr>

      </table>
    </div>

    <!-- Advanced Parameters -->
     <div id="content2" class="tabcontent" style="display:none;">
<!--Upper Level Table-->
<table>
<tr valign="top"><td>
      <table width=250 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">Encoding</font></strong></td></tr>
       <tr>
        <td>PAL-N Composite/S-Video</td>
        <td>
         <select name="VIDEO_PAL_N">
          <option $PAL_N_ON_Selected>Yes</option>
          <option $PAL_N_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Capture Closed Caption (CC)</td>
        <td>
         <select name="CLOSED_CAPTION">
          <option $CLOSED_CAPTION_ON_Selected>Yes</option>
          <option $CLOSED_CAPTION_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Low Delay</td>
        <td>
         <select name="LOW_DELAY">
          <option $LOW_DELAY_ON_Selected>Yes</option>
          <option $LOW_DELAY_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
EOT
    if [ $HAS_SDI != false ] ; then
        cat << EOT
       <tr>
        <td>Analog audio input for HD Video</td>
        <td>
         <select name="ANALOG_HDVIDEO">
          <option $ANALOG_HDVIDEO_ON_Selected>Yes</option>
          <option $ANALOG_HDVIDEO_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
EOT
    fi
    cat << EOT
       <tr>
        <td>Audio Channels</td>
        <td>
         <select name="AUDIO_CHANNELS">
          <option $AUDIO_CHANNELS_1_Selected>1</option>
          <option $AUDIO_CHANNELS_2_Selected>2</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Video Filtering</td>
        <td>
         <select name="VIDEO_FILTER">
          <option $VID_FLT_ON_Selected>On</option>
          <option $VID_FLT_OFF_Selected>Off</option>
         </select>
        </td>
       </tr>
       <!--
       <tr>
        <td>Video Sharpness</td>
        <td>
         <select name="SHARPNESS">
          <option $SHARPNESS_DFLT_Selected>default</option>
          <option $SHARPNESS_SMOOTH_Selected>smooth</option>
          <option $SHARPNESS_MEDIUM_Selected>medium</option>
          <option $SHARPNESS_SHARP_Selected >sharp</option>
         </select>
        </td>
       </tr>
       -->
       <tr>
        <td>Video Frame Rate${FOR_SD}</td>
        <td>
         <select name="FRAME_RATE">
          <option $FR_Full_Selected>Full</option>
          <option $FR_Half_Selected>Half</option>
          <!--
          <option $FR_Third_Selected>Third</option>
          -->
         </select>
        </td>
       </tr>
       <tr>
        <td>Video Resolution${FOR_SD}</td>
        <td>
         <select name="VIDEO_SD_RES">
          <option $VID_default_Selected>Full</option>
EOT
    if [ $HAS_HD_RESIZE = true ] ; then
        echo "          <option $VID_D1_Selected>D1</option>"
    fi
    cat << EOT
          <option $VID_HALF_D1_Selected>Half</option>
          <option $VID_CIF_Selected>CIF</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Video Aspect Ratio${FOR_SD}</td>
        <td>
         <select name="VIDEO_ASPECT">
          <option $VID_4x3_Selected>4x3</option>
          <option $VID_16x9_Selected>16x9</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Number P frames</td>
        <td>
         <select name="NUM_P_FRAMES">
          <option $P_FRAME_0_Selected>0</option>
          <option $P_FRAME_1_Selected>1</option>
          <option $P_FRAME_2_Selected>2</option>
          <option $P_FRAME_3_Selected>3</option>
          <option $P_FRAME_4_Selected>4</option>
          <option $P_FRAME_5_Selected>5</option>
          <option $P_FRAME_9_Selected>9</option>
          <option $P_FRAME_14_Selected>14</option>
          <option $P_FRAME_29_Selected>29</option>
          <option $P_FRAME_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Number B frames</td>
        <td>
         <select name="NUM_B_FRAMES">
          <option $B_FRAME_0_Selected>0</option>
          <option $B_FRAME_1_Selected>1</option>
          <option $B_FRAME_2_Selected>2</option>
          <option $B_FRAME_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>MPEG4 Profile</td>
        <td>
         <select name="PROFILE">
          <option $PROFILE_B_Selected>Base</option>
          <option $PROFILE_M_Selected>Main</option>
          <option $PROFILE_H_Selected>High</option>
          <option $PROFILE_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>MPEG4 Level</td>
        <td>
         <select name="LEVEL">
          <option $LEVEL_12_Selected>1.2</option>
          <option $LEVEL_20_Selected>2.0</option>
          <option $LEVEL_21_Selected>2.1</option>
          <option $LEVEL_22_Selected>2.2</option>
          <option $LEVEL_30_Selected>3.0</option>
          <option $LEVEL_31_Selected>3.1</option>
          <option $LEVEL_32_Selected>3.2</option>
          <option $LEVEL_40_Selected>4.0</option>
          <option $LEVEL_41_Selected>4.1</option>
          <option $LEVEL_A_Selected>auto</option>
         </select>
        </td>
       </tr>
       <!--
       <tr>
        <td>Stream Type</td>
        <td>
         <select name="STREAM_TYPE">
          <option $TS_Selected>Transport</option>
          <option $MP4_Selected>MP4</option>
         </select>
        </td>
       </tr>
       -->
</table></td><td>

      <table width=300 class=props border="1" cellpadding="2" cellspacing="1">
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">Control</font></strong></td></tr>
       <tr align="left">
        <td>Error Handling</td>
        <td>
         <select name="ENCODER_ACTION">
          <option $EncAction_None_Selected>None</option>
          <option $EncAction_Restart_Selected>Restart</option>
          <option $EncAction_Reboot_Selected>Reboot</option>
         </select>
        </td>
       </tr>
EOT
    if [ $HAS_SDI != false ] ; then
        cat << EOT
       <tr>
        <td>Resync SDI</td>
        <td>
         <select name="RESYNC_SDI">
          <option $RESYNC_SDI_ON_Selected>Yes</option>
          <option $RESYNC_SDI_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
       <tr>
        <td>Resync HDMI</td>
        <td>
         <select name="RESYNC_HDMI">
          <option $RESYNC_HDMI_ON_Selected>Yes</option>
          <option $RESYNC_HDMI_OFF_Selected>No</option>
         </select>
        </td>
       </tr>
EOT
    fi
    cat << EOT
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">Output</font></strong></td></tr>
       <tr align="left">
        <td>PMT PID</td>
        <td><input name="PMT_PID" size="8" maxlength="8" value="$PMT_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>Video PID</td>
        <td><input name="VIDEO_PID" size="8" maxlength="8" value="$VIDEO_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>Audio PID</td>
        <td><input name="AUDIO_PID" size="8" maxlength="8" value="$AUDIO_PID" type="text"></td>
       </tr>
       <tr align="left">
        <td>PCR PID<br>(usually=Video PID)</td>
        <td><input name="PCR_PID" size="8" maxlength="8" value="$PCR_PID" type="text"></td>
       </tr>
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">Network</font></strong></td></tr>
       <tr align="left">
        <td>TS pkts/IP pkt</td>
        <td><input name="NUM_TS_PKTS_PER_IP_PKT" size="8" maxlength="8" value="$NUM_TS_PKTS_PER_IP_PKT" type="text"></td>
       </tr>
       <tr>
         <td>Use Pacing</td>
         <td><input type=radio name="USE_PACING" value="1" $PACING1_CHECKED >Yes
             <input type=radio name="USE_PACING" value="0" $PACING0_CHECKED >No
         </td>
       </tr>
<!--
       <tr align="left">
        <td>Unicast TTL (Time-To-Live)</td>
        <td><input name="UNI_TTL" size="8" maxlength="8" value="$UNI_TTL" type="text"></td>
       </tr>
       <tr align="left">
        <td>Multicast TTL (Time-To-Live)</td>
        <td><input name="M_TTL" size="8" maxlength="8" value="$M_TTL" type="text"></td>
       </tr>
       <tr align="left">
        <td>TOS (Type-of-Service)</td>
        <td><input name="TOS" size="8" maxlength="8" value="$TOS" type="text"></td>
       </tr>
-->
       <tr align="left">
        <td>Insert Metadata</td>
        <td><input type=radio name="DO_METADATA" value="1" $METADATA1_CHECKED >Yes
            <input type=radio name="DO_METADATA" value="0" $METADATA0_CHECKED >No
        </td>
       </tr>
       <tr align="left">
        <td>Metadata UDP Port</td>
        <td><input name="METADATA_PORT" size="8" maxlength="8" value="$METADATA_PORT" type="text"></td>
       </tr>
       <tr align="left">
        <td>Network Bonding<br>(generally off)</td>
        <td><input type=radio name="BOND_PORTS" value="true" $BOND_TRUE_CHECKED  onClick=verifyBond()>On
            <input type=radio name="BOND_PORTS" value="false" $BOND_FALSE_CHECKED  onClick=verifyBond()>Off
        </td>
       <tr align="left">
        <td>LAN1 Bond Pct</td>
        <td><input name="LAN1_PERCENT" size="3" maxlength="3" value="$LAN1_PERCENT" type="text" xx()>%</td>
       </tr>
       <tr align="left">
        <td>ARQ Buffers</td>
        <td>
         <select name="ARQ_TX_BUFS">
          <option $ARQ_TX_BUFS_1024_Selected>1024</option>
          <option $ARQ_TX_BUFS_2048_Selected>2048</option>
          <option $ARQ_TX_BUFS_4096_Selected>4096</option>
         </select>
        </td>
       </tr>
       </tr>
      </table>
</td></tr></table>
    </div>                                                                                                             
 
 <input value="    Save    " type="submit">
 <input value="    Cancel    " type="reset"></td>
 </form>
</body>
</html>
EOT

else
    eval `./cgiparse "$QUERY_STRING"`

    [ "$CONF_FILE" = "" ] && CONF_FILE=/flash/qvidium/encoder/profile

    [ $NUM_TS_PKTS_PER_IP_PKT -gt 7 ] && NUM_TS_PKTS_PER_IP_PKT=7
    [ $NUM_TS_PKTS_PER_IP_PKT -lt 1 ] && NUM_TS_PKTS_PER_IP_PKT=1
    [ "$UDP_PORT" = "" ] && UDP_PORT=10000
    [ $UDP_PORT -gt 65535 ] && UDP_PORT=65535
    [ $UDP_PORT -lt 0 ] && UDP_PORT=10000
    [ "$ARQ_PORT" = "" ] && ARQ_PORT=7020
    [ $ARQ_PORT -gt 65535 ] && ARQ_PORT=7020
    [ $ARQ_PORT -lt 0 ] && ARQ_PORT=7020

    [ "$TS_BITRATE" -gt 20000000 ] && TS_BITRATE=20000000
    
    [ "$UNI_TTL" -lt 1 ] && UNI_TTL=1
    [ "$UNI_TTL" -gt 255 ] && UNI_TTL=255
    [ "$M_TTL" -lt 1 ] && M_TTL=1
    [ "$M_TTL" -gt 255 ] && M_TTL=255

    cat << EOT > $CONF_FILE
CLOSED_CAPTION=$CLOSED_CAPTION
LOW_DELAY=$LOW_DELAY
BOND_PORTS=$BOND_PORTS
LAN1_PERCENT=$LAN1_PERCENT
FRAME_RATE=$FRAME_RATE
STREAM_TYPE=$STREAM_TYPE
TS_BITRATE=$TS_BITRATE
NUM_B_FRAMES=$NUM_B_FRAMES
NUM_P_FRAMES=$NUM_P_FRAMES
PROFILE=$PROFILE
LEVEL=$LEVEL
VIDEO_PID=$VIDEO_PID
AUDIO_PID=$AUDIO_PID
PCR_PID=$PCR_PID
PMT_PID=$PMT_PID
VIDEO_BITRATE=$VIDEO_BITRATE
ANALOG_HDVIDEO=$ANALOG_HDVIDEO
RESYNC_SDI=$RESYNC_SDI
RESYNC_HDMI=$RESYNC_HDMI
AUDIO_CHANNELS=$AUDIO_CHANNELS
AUDIO_BITRATE=$AUDIO_BITRATE
AUDIO_SAMPLE_RATE=$AUDIO_SAMPLE_RATE
AUDIO_ENCODING="$AUDIO_ENCODING"
VIDEO_ENCODING="$VIDEO_ENCODING"
VIDEO_INPUT=$VIDEO_INPUT
VIDEO_FILTER=$VIDEO_FILTER
ENCODER_ACTION=$ENCODER_ACTION
VIDEO_PAL_N=$VIDEO_PAL_N
SHARPNESS=$SHARPNESS
VIDEO_SD_RES=$VIDEO_SD_RES
VIDEO_ASPECT=$VIDEO_ASPECT
OUTPUT=$OUTPUT
TRANSPORT=$TRANSPORT
IPADDR_OR_HOSTNAME=$IPADDR_OR_HOSTNAME
UDP_PORT=$UDP_PORT
NUM_TS_PKTS_PER_IP_PKT=$NUM_TS_PKTS_PER_IP_PKT
USE_PACING=$USE_PACING
ARQ_PORT=$ARQ_PORT
ARQ_TX_BUFS=$ARQ_TX_BUFS
DO_METADATA=$DO_METADATA
METADATA_PORT=$METADATA_PORT
UNI_TTL=$UNI_TTL
M_TTL=$M_TTL
TOS=$TOS
EOT

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Profile Status</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
</head>
<body>
 <h2><center>Profile Status</center></h2>
 OK. <br><br>Press the "Profile" option to update view.
</body>
</html>
EOT

fi

