#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

if [ "$QUERY_STRING" = "" ]; then
    not_running=1
    tmp=`echo "$HTTP_REFERER" | sed 's/^.*?//'`
    eval `./cgiparse "$tmp"`
    case "$page" in
        *2) NUM=2
            pidof encoder2 > /dev/null && not_running=0
            ;;
         *) NUM=1
            pidof encoder1 > /dev/null && not_running=0
            ;;
    esac
    dev_qvencode=/dev/qvencode$NUM

    if [ $not_running = 1 ] ; then
        cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Encoder $NUM Bitrate</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
  <h2><center>Encoder $NUM Bitrate</center></h2>
Encoder $NUM not running.
</body>
</html>
EOT
       exit 0
    fi
    eval `/qvidium/qvctrl $dev_qvencode get_videobitrate`
    [ "$VIDEO_BITRATE" = "" ] && VIDEO_BITRATE="unknown"
else
    NUM=1
    eval `./cgiparse "$QUERY_STRING"`
    dev_qvencode=/dev/qvencode$NUM
    
    if [ -n "$VIDEO_BITRATE" ] ; then
        eval `/qvidium/qvctrl $dev_qvencode "set_videobitrate $VIDEO_BITRATE"`
    else
        VIDEO_BITRATE="unknown"
    fi
fi

cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Encoder $NUM Bitrate</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
  <script languang=javascript>
    function IsNumeric(str)
    {
      var ValidChars = "0123456789";
      var Char;

      for (i = 0; i < str.length; i++) {
        Char = str.charAt(i);
        if (ValidChars.indexOf(Char) == -1) return false;
      }
      return true;
    }

    function verify()
    {
      var tmp;

      tmp = document.forms[0].VIDEO_BITRATE.value;
      if (IsNumeric(tmp) == false || tmp < 128000 || tmp > 25000000)
      {
        alert('Video bitrate "'+tmp+'" is not valid [128000,25000000].');
        return false;
      }
      return true;
    }
  </script>
</head>
<body>
  <h2><center>Encoder $NUM Bitrate</center></h2>
<br>
 <form action="/cgi-bin/encoder_bitrate.cgi" method="get" name="encoder_bitrate" onSubmit="return verify()">
   <input id="NUM" type="hidden" name="NUM" value="$NUM">
   <table class=props cellSpacing="1" cellPadding="10" border="1">
    <tr>
      <td>Bitrate:</td>
      <td><input type=text name="VIDEO_BITRATE" size=10 value=$VIDEO_BITRATE></TD>
    </tr>
   </table>
  <p>
  <input type=submit value="Change Bitrate">
 </form>
</body>
</html>
EOT
