#!/bin/sh
#
# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.
#

echo -e "Content-type: text/html\n"

file=/flash/qvidium/encoder/profile
. $file

# get remote system's IP address
newdest=$REMOTE_ADDR

if [ "$QUERY_STRING" != "" ] ; then
    # parse URL for newdest (newdest is optional)
    eval `./cgiparse "$QUERY_STRING"`
fi

# reset encoder if remote addrss has changed
if [ "$IPADDR_OR_HOSTNAME" != "$newdest" ] ; then
    tmpfile=/tmp/profile.$$
    sed 's/^.*IPADDR_OR_HOSTNAME=.*$/IPADDR_OR_HOSTNAME='$newdest'/' $file > $tmpfile
    cp $tmpfile $file
    rm -f $tmpfile
    sync

    ENCODE_CONFIG=/flash/qvidium/net_out.conf
    CODEC_CONFIG=/flash/qvidium/net_in_out.conf

    if [ -f $ENCODE_CONFIG ] ; then
        /qvidium/rc.net_out start $file
    elif [ -f $CODEC_CONFIG ] ; then
        /qvidium/rc.net_in_out start $file /flash/qvidium/decoder/profile
    fi
fi

cat << EOT
<html>
<head>
<title>Decoder Destination</title>
</head>
<body>
<h2><center>Decoder Destination</center></h2>
<p>Destination: <strong>$newdest</strong><br><p><p>
</body>
</html>
EOT
