#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

NUM=1
PROFILE=profile
tmp=`echo "$HTTP_REFERER" | sed 's/^.*?//'`
if [ "$tmp" != "" ] ; then
  eval `./cgiparse "$tmp"`
  case "$page" in
    *2) NUM=2 ; PROFILE=profile2 ;;
     *) NUM=1 ; PROFILE=profile ;;
  esac
fi

# Print common header
cat << ENDHTML
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<LINK rel="stylesheet" href="/style.css" type="text/css">
<TITLE>Encoder $NUM Status</TITLE>
ENDHTML

pidof encoder$NUM > /dev/null
if [ $? != 0 ] ; then
    cat << ENDHTML
</HEAD>
<BODY>
<P align="center"><STRONG>
<FONT size="5">Encoder $NUM Status</P>
<P align="left"></FONT></STRONG>
<strong><FONT size=4>Encoder is HALTED</font></strong>
<p>Not sending to network.</p>
</BODY>
</HTML>
ENDHTML
   exit 0
fi

STATUS_FILE=/var/run/net_out$NUM.status
# Read in current stats from *.status in /var/run
#if [ -f $STATUS_FILE ] ; then

    if [ "$QUERY_STRING" != "" ] ; then
        cat << ENDHTML
<SCRIPT LANGUAGE=JAVASCRIPT>

  function RefreshPage()
  {
     window.location.reload(true);
  }

  function StartTimer()
  {
     window.setTimeout("RefreshPage()", 3000);
  }

</SCRIPT>
</HEAD>
<BODY onload="StartTimer();">
ENDHTML
    else
        cat << ENDHTML
</HEAD>
<BODY>
ENDHTML
    fi
    cat << ENDHTML
<P align="center"><STRONG>
<FONT size="5">Encoder $NUM Status</P>
<P align="left"></FONT></STRONG>
ENDHTML

    STARTED=`cat /var/log/net_out$NUM.start`
    STATS_CLEARED=`cat /var/log/net_out$NUM.stats`
    
    echo "Current Time: "
    date -R
    echo "<br>"
    
    TRANSPORT=UDP
    if [ -f /flash/qvidium/encoder/$PROFILE ] ; then
        . /flash/qvidium/encoder/$PROFILE
    fi

    [ -f $STATUS_FILE ] && eval `grep '[A-Z].*=' $STATUS_FILE`
    #. $STATUS_FILE 2> /dev/null

    cat << ENDHTML
        <TABLE class=props cellSpacing="1" cellPadding="2" border="1">
          <tr align=center><td colSpan="2" nowrap><strong><font size="4">Stream</font></strong></td></tr>
          <TR><TD width="160">Started:</TD><TD width="300">$STARTED</TD></TR>
ENDHTML
    if [ "$OUTPUT" = ASI ] ; then
      cat << ENDHTML
          <TR><TD width="160">Output:</TD><TD width="300">$OUTPUT</TD></TR>
ENDHTML
    else
      cat << ENDHTML
          <TR><TD width="160">Stats Cleared:</TD><TD width="300">$STATS_CLEARED</TD></TR>
          <tr align=center><td colSpan="2" nowrap><strong><font size="4">Network</font></strong></td></tr>
          <TR><TD width="160">Transport:</TD><TD width="300">$TRANSPORT</TD></TR>
          <TR><TD width="160">Bitrate:</TD><TD width="300">$NET_BITRATE</TD></TR>
          <TR><TD width="160">Total Packets:</TD><TD width="300">$NET_TOTAL_PACKETS</TD></TR>
ENDHTML
    fi
    if [ "$TRANSPORT" = ARQ ] ; then
        cat << ENDHTML
           <tr align=center><td colSpan="2" nowrap><strong><font size="4">ARQ</font></strong></td></tr>
           <TR><TD width="160">Resent:</TD><TD width="300">$ARQ_RESENT</TD></TR>
           <TR><TD width="160">Missing:</TD><TD width="300">$ARQ_MISS</TD></TR>
           <TR><TD width="160">Max Burst Loss:</TD><TD width="300">$ARQ_MAXBURSTLOSS</TD></TR>
           <TR><TD width="160">Stale Requests:</TD><TD width="300">$ARQ_STALE</TD></TR>
           <TR><TD width="160">Ignored Requests:</TD><TD width="300">$ARQ_IGNORED</TD></TR>
           <TR><TD width="160">Delay:</TD><TD width="300">$ARQ_DELAY</TD></TR>
           <TR><TD width="160">Number Retries:</TD><TD width="300">$ARQ_NUM_RETRIES</TD></TR>
           <TR><TD width="160">Round Trip Time:</TD><TD width="300">$ARQ_RTT</TD></TR>
ENDHTML
    fi
   
    echo "</TABLE>"

#else
#    cat << ENDHTML
#</HEAD>
#<BODY>
#<P align="center"><STRONG>
#<FONT size="5">Encoder Status</P>
#<P align="left"></FONT></STRONG>
#<p><FONT size=4>No network send stats available.</P>
#ENDHTML
#fi

cat << ENDHTML
</BODY>
</HTML>
ENDHTML

exit 0
