#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

HAS_SDI=false
[ -f /flash/qvidium/inputs.conf ] && . /flash/qvidium/inputs.conf
[ "$HAS_SDI" = "" ] && HAS_SDI=false

VID_DEC_I2C=82
MAX_GAIN=127
MAX_ATTENUATION=127
DEFAULT_GAIN=25
DEFAULT_ATTENUATION=127
GAIN=25
ATTENUATION=127
CONSUMER=126
US_PROFESSIONAL=116
EU_PROFESSIONAL=114

ENCVOL_CONF=/flash/qvidium/encoder_volume.conf
VID_DEC_CONF=/var/run/vid_dec.conf

[ -f $ENCVOL_CONF ] && . $ENCVOL_CONF
[ -f $VID_DEC_CONF ] && . $VID_DEC_CONF

if [ "$QUERY_STRING" = "" ]; then

    not_running=1
    if pidof encoder1 > /dev/null ; then
        not_running=0
    elif pidof encoder2 > /dev/null ; then
        not_running=0
    fi

    if [ $not_running = 1 ] ; then
        cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Encoder Volume</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
  <h2><center>Encoder Volume</center></h2>
Encoder not running.
</body>
</html>
EOT
        exit 0
    fi
else
    eval `./cgiparse "$QUERY_STRING"`

    ATTENUATION_ARGS=
    GAIN_ARGS=
    
    if [ "$ATTENUATE_MORE" != "" ] ; then
        ATTENUATION=$((ATTENUATION - 1))
        if [ $ATTENUATION -lt 0 ] ; then
            ATTENUATION=0
            msg="Attenuation at maximum, not changed"
        else
            ATTENUATION_ARGS=`printf "1800%02x00" $ATTENUATION`
        fi
    elif [ "$ATTENUATE_LESS" != "" ] ; then
        ATTENUATION=$((ATTENUATION + 1))
        if [ $ATTENUATION -gt $MAX_ATTENUATION ] ; then
            ATTENUATION=$MAX_ATTENUATION
            msg="Attenuation at minimum, not changed"
        else
            ATTENUATION_ARGS=`printf "1800%02x00" $ATTENUATION`
        fi
    elif [ "$GAIN_DOWN" != "" ] ; then
        if [ $GAIN = 0 ] ; then
            msg="Gain not changed"
        else
            GAIN=$((GAIN - 1))
            GAIN_ARGS=`printf "180d%02x00" $GAIN`
        fi
    elif [ "$GAIN_DOWN_5" != "" ] ; then
        if [ $GAIN = 0 ] ; then
            msg="Gain not changed"
        else
            GAIN=$((GAIN - 5))
            [ $GAIN -lt 0 ] && GAIN=0
            GAIN_ARGS=`printf "180d%02x00" $GAIN`
        fi
    elif [ "$GAIN_UP" != "" ] ; then
        if [ $GAIN = $MAX_GAIN ] ; then
            msg="Gain not changed"
        else
            GAIN=$((GAIN + 1))
            GAIN_ARGS=`printf "180d%02x00" $GAIN`
        fi
    elif [ "$GAIN_UP_5" != "" ] ; then
        if [ $GAIN = $MAX_GAIN ] ; then
            msg="Gain not changed"
        else
            GAIN=$((GAIN + 5))
            [ $GAIN -gt $MAX_GAIN ] && GAIN=$MAX_GAIN
            GAIN_ARGS=`printf "180d%02x00" $GAIN`
        fi
    elif [ "$SET_CONSUMER" != "" ] ; then
        ATTENUATION=$CONSUMER
        ATTENUATION_ARGS=`printf "1800%02x00" $ATTENUATION`
        GAIN=$DEFAULT_GAIN
        GAIN_ARGS=`printf "180d%02x00" $GAIN`
    elif [ "$SET_US_PROFESSIONAL" != "" ] ; then
        ATTENUATION=$US_PROFESSIONAL
        ATTENUATION_ARGS=`printf "1800%02x00" $ATTENUATION`
        GAIN=$DEFAULT_GAIN
        GAIN_ARGS=`printf "180d%02x00" $GAIN`
    elif [ "$SET_EU_PROFESSIONAL" != "" ] ; then
        ATTENUATION=$EU_PROFESSIONAL
        ATTENUATION_ARGS=`printf "1800%02x00" $ATTENUATION`
        GAIN=$DEFAULT_GAIN
        GAIN_ARGS=`printf "180d%02x00" $GAIN`
    else
        msg=""
    fi
    if [ "$ATTENUATION_ARGS" != "" ] ; then
        msg="Set attenuation OK"
        i2c $VID_DEC_I2C $ATTENUATION_ARGS > /dev/null 2>&1
        [ $? != 0 ] && msg="Set attenuation failed: $?"
    fi
    if [ "$GAIN_ARGS" != "" ] ; then
        msg2="Set gain OK"
        i2c $VID_DEC_I2C $GAIN_ARGS > /dev/null 2>&1
        [ $? != 0 ] && msg2="Set gain failed: $?"
        if [ "$msg" = "" ] ; then
            msg=$msg2
        else
            msg="$msg<br>$msg2"
        fi
    fi
    cat << EOF > $ENCVOL_CONF
GAIN=$GAIN
ATTENUATION=$ATTENUATION
EOF
    sync
fi

SDI_MSG=
[ $HAS_SDI = true ] && SDI_MSG='This only affects the analog input volume. This does not affect the SDI or HDMI input audio.<br><br>'

cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Encoder Volume</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
  <h2><center>Encoder Volume</center></h2>
$SDI_MSG
$msg
<br>
<form action="/cgi-bin/encoder_volume.cgi" method="get" name="encoder_volume">
  <h3>Presets</h3>
  <input value="Consumer" type="submit" name="SET_CONSUMER">
  <input value="USA Professional" type="submit" name="SET_US_PROFESSIONAL">
  <input value="Europe Professional" type="submit" name="SET_EU_PROFESSIONAL">
  <h3>Custom Controls</h3>
  Attenuate ($ATTENUATION): 
  <input value="More" type="submit" name="ATTENUATE_MORE">
  <input value="Less" type="submit" name="ATTENUATE_LESS">
  <br><br>
  Gain ($GAIN): 
  <input value="Up 5" type="submit" name="GAIN_UP_5">
  <input value="Up 1" type="submit" name="GAIN_UP">
  <input value="Down 1" type="submit" name="GAIN_DOWN">
  <input value="Down 5" type="submit" name="GAIN_DOWN_5">
  <br><br>
</form>
</body>
</html>
EOT
