#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

if [ "$QUERY_STRING"x = x ]; then
    LOG_LEVEL=0
    if [ -r /flash/qvidium/log.conf ] ; then
      . /flash/qvidium/log.conf
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Messages Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
<h2><center>Messages Configuration</center></h2>
Current Messages Level: $LOG_LEVEL (0=least detail to 9=most detail)<br><br>
<form name="log" method="get" action="logging_conf.cgi">
  <table class=props id="LogLevel" cellSpacing="1" cellPadding="5" border="1">
    <tbody>
      <tr align="left">
        <td>Message Level (0-9)</td>
        <td><input name="LOG_LEVEL" size="16" maxlength="15" value="$LOG_LEVEL"> </td>
      </tr>
    </tbody>
  </table>
  <p>
  <input value="Apply" type="submit">
</form>
</body>
</html>
EOT

else
# First get old log level, if doesn't exist, then set default
    LOG_LEVEL=0
    if [ -r /flash/qvidium/log.conf ] ; then
      . /flash/qvidium/log.conf
    fi
    olog_level=$LOG_LEVEL
    if [ "$olog_level"x = x ] ; then
      olog_level=0
    fi

    LOG_LEVEL=
    eval `./cgiparse "$QUERY_STRING"`

    if [ "$LOG_LEVEL"x = x ] ; then 
# Try to recover a value for LOG_LEVEL, else set default
      if [ -r /flash/qvidium/log.conf ] ; then
        cp /flash/qvidium/log.conf /etc/log.conf
        . /etc/log.conf
      fi
      if [ "$LOG_LEVEL"x = x ] ; then
# Log level not set, create default config file
        LOG_LEVEL=0
        echo "LOG_LEVEL=0" > /etc/log.conf
        cp /etc/log.conf /flash/qvidium/log.conf
      fi
    else
      echo "LOG_LEVEL=$LOG_LEVEL" > /etc/log.conf
      cp /etc/log.conf /flash/qvidium/log.conf
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Messages Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
EOT
    if [ "$LOG_LEVEL"x != "$olog_level"x ] ; then
        echo "New Messages Level: $LOG_LEVEL (was $olog_level)<br>"
        echo "If running: please restart to take effect<br><br>"
    fi
    cat << EOT
Current Messages Level: $LOG_LEVEL<br><br>
</body>
</html>
EOT

fi

