#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

RC_CONF="/flash/etc/rc.conf"

[ -r $RC_CONF ] && . $RC_CONF
[ "$mcast_dev" = "" ] && mcast_dev=eth0

if [ "$QUERY_STRING" = "" ]; then

    if [ "$mcast_dev" = "eth1" ]; then
      dflt_mcast_lan2="CHECKED"
      mcast_status="LAN2"
    else
      dflt_mcast_lan1="CHECKED"
      mcast_status="LAN1"
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Multicast LAN Port Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
<h2><center>Multicast LAN Port Configuration</center></h2>
<form name="mgmt_conf" method="get" action="mcast_conf.cgi">
Multicast port is $mcast_status:<br><br>
  <table class=props id="LogLevel" cellSpacing="1" cellPadding="5" border="1">
    <tbody>
      <tr align="left">
        <td>Multicast port</td>
        <td>
          <input name="mcast_dev" type="radio" value="eth0" $dflt_mcast_lan1>LAN1
          <input name="mcast_dev" type="radio" value="eth1" $dflt_mcast_lan2>LAN2
        </td>
      </tr>
    </tbody>
  </table>
  <input value="Apply" type="submit">
</form>
</body>
</html>
EOT

else
    omcast_dev=$mcast_dev

    eval `./cgiparse "$QUERY_STRING"`

    mcast_stat="LAN1"
    [ $mcast_dev = "eth1" ] && mcast_stat="LAN2"

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Multicast LAN Port Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
EOT

    if [ $omcast_dev != $mcast_dev ]; then
        # Delete old PING_DISABLE
        tmpfile="/tmp/rc_conf.$$"
        sed -e '/mcast_dev/d' $RC_CONF > $tmpfile

        # Add new settings
        echo "mcast_dev=$mcast_dev" >> $tmpfile
        
        rm -f $RC_CONF
        sync
        mv $tmpfile $RC_CONF
        sync

        # Delete any multicast route
        route del -net 224.0.0.0 netmask 240.0.0.0 > /dev/null 2>&1
                                        
        # Setup multicast route
        route add -net 224.0.0.0 netmask 240.0.0.0 dev $mcast_dev

        # Restart ifconfig_server on mcast_dev
        pidof ifconfig_server > /dev/null && killall ifconfig_server
        /qvidium/ifconfig_server -i $mcast_dev > /dev/null 2>&1 &
    fi

    cat << EOT
<h3>Multicast port is $mcast_stat</h3><br><br>
</body>
</html>
EOT

fi
