#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

RC_CONF="/flash/etc/rc.conf"

WEBADMIN_PORT=80
SSH_PORT=22
SSH_ALLOW_ROOT_LOGIN=yes
telnetd_disable="no"
telnetd_disable2="no"
[ -r $RC_CONF ] && . $RC_CONF
[ "$HTTP_DISABLE" = "" ] && HTTP_DISABLE=false

if [ "$QUERY_STRING"x = x ]; then

    if [ "$HTTP_DISABLE" = "true" ]; then
      dflt_web_disabled="CHECKED"
      web_status="Disabled"
    else
      dflt_web_enabled="CHECKED"
      web_status="Enabled"
    fi

    if [ $telnetd_disable2 = "yes" ]; then
      dflt_tlnt1="CHECKED"
      tlnt_status="Disabled"
    else
      dflt_tlnt2="CHECKED"
      tlnt_status="Enabled"
    fi

    if [ "$SSH_ALLOW_ROOT_LOGIN" = "yes" ]; then
      dflt_rootlogin1="CHECKED"
    else
      dflt_rootlogin2="CHECKED"
    fi
    
    if [ $telnetd_disable = "yes" ]; then
      dflt_ssh1="CHECKED"
      ssh_status="Disabled"
    else
      dflt_ssh2="CHECKED"
      ssh_status="Enabled"
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Management Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
<h2><center>Management Configuration</center></h2>
<form name="mgmt_conf" method="get" action="mgmt_conf.cgi">
HTTP Web Management Port (currently at Port $WEBADMIN_PORT, status is $web_status):<br><br>
  <table class=props id="LogLevel" cellSpacing="1" cellPadding="5" border="1">
    <tbody>
      <tr align="left">
        <td>Web admin port (default:80)</td>
        <td><input name="WEBADMIN_PORT" size="16" maxlength="15" value="$WEBADMIN_PORT"> </td>
      </tr>
      <tr align="left">
        <td>WEB (http) Access</td>
        <td>
          <input name="HTTP_DISABLE" type="radio" value="false" $dflt_web_enabled>Enable 
          <input name="HTTP_DISABLE" type="radio" value="true" $dflt_web_disabled>Disable
        </td>
      </tr>
    </tbody>
  </table>
    </tbody>
  </table>
  <p>
Secure Shell (ssh) (TCP Port $SSH_PORT, Current status $ssh_status):<br><br>
  <table class=props id="LogLevel" cellSpacing="1" cellPadding="5" border="1">
    <tbody>
      <tr align="left">
        <td>SSH port (default:22)</td>
        <td><input name="SSH_PORT" size="16" maxlength="15" value="$SSH_PORT"> </td>
      </tr>
      <tr align="left">
        <td>Allow root login</td>
        <td>
          <input name="SSH_ALLOW_ROOT_LOGIN" type="radio" value="yes" $dflt_rootlogin1>Enable 
          <input name="SSH_ALLOW_ROOT_LOGIN" type="radio" value="no" $dflt_rootlogin2>Disable
        </td>
      </tr>
      <tr align="left">
        <td>Secure Shell (ssh) Access</td>
        <td>
          <input name="telnetd_disable" type="radio" value="no" $dflt_ssh2>Enable 
          <input name="telnetd_disable" type="radio" value="yes" $dflt_ssh1>Disable
        </td>
      </tr>
    </tbody>
  </table>
  <p>
Telnet Access (TCP Port 23, Current status $tlnt_status):<br><br>
  <table class=props id="LogLevel" cellSpacing="1" cellPadding="5" border="1">
    <tbody>
      <tr align="left">
        <td>Telnet Access</td>
        <td>
          <input name="telnetd_disable2" type="radio" value="no" $dflt_tlnt2>Enable 
          <input name="telnetd_disable2" type="radio" value="yes" $dflt_tlnt1>Disable
        </td>
      </tr>
    </tbody>
  </table>
  <p>
  <input value="Apply" type="submit">
</form>
</body>
</html>
EOT

else
# First get old webadmin port & telnet_disable values, 
# If they don't exist, then default values are used
    oWEBADMIN_PORT=$WEBADMIN_PORT
    otelnetd_disable2=$telnetd_disable2
    otelnetd_disable=$telnetd_disable
    oHTTP_DISABLE=$HTTP_DISABLE
    oSSH_PORT=$SSH_PORT
    oSSH_ALLOW_ROOT_LOGIN=$SSH_ALLOW_ROOT_LOGIN

    eval `./cgiparse "$QUERY_STRING"`

    if [ "$WEBADMIN_PORT"x = x ] ; then 
# Not set => use default
      WEBADMIN_PORT=80
    fi
    telnet_stat="ENABLED"
    [ $telnetd_disable = "yes" ] && telnet_stat="DISABLED"
    telnet_stat2="ENABLED"
    [ $telnetd_disable2 = "yes" ] && telnet_stat2="DISABLED"
    web_stat="ENABLED"
    [ $HTTP_DISABLE = "true" ] && web_stat="DISABLED"

# Save new settings ONLY if one of the values changed
    # if [ $oHTTP_DISABLE != $HTTP_DISABLE -o $otelnetd_disable != $telnetd_disable -o $oWEBADMIN_PORT != $WEBADMIN_PORT -o $otelnetd_disable2 != $telnetd_disable2 ]; then
        # Delete old web port and telnet settings
        tmpfile="/tmp/rc_conf.$$"
        sed -e '/HTTP_DISABLE/d' -e '/WEBADMIN_PORT/d' -e '/telnetd_disable/d' \
            -e '/telnetd_disable2/d' -e '/SSH_PORT/d' -e '/SSH_ALLOW_ROOT_LOGIN/d' $RC_CONF > $tmpfile

        # Add new settings
        echo "WEBADMIN_PORT=$WEBADMIN_PORT" >> $tmpfile
        echo "SSH_PORT=$SSH_PORT" >> $tmpfile
        echo "SSH_ALLOW_ROOT_LOGIN=$SSH_ALLOW_ROOT_LOGIN" >> $tmpfile
        echo "HTTP_DISABLE=$HTTP_DISABLE" >> $tmpfile

        telnet_stat="ENABLED"
        if [ "$telnetd_disable"x != x ]; then
          echo "telnetd_disable=$telnetd_disable" >> $tmpfile
          if [ $telnetd_disable = "yes" ]; then
            telnet_stat="DISABLED"
            /disk/dropbear/rc.ssh stop
          elif [ $otelnetd_disable != $telnetd_disable ]; then
            /disk/dropbear/rc.ssh start
          fi
        fi
        
        telnet_stat2="ENABLED"
        if [ "$telnetd_disable2"x != x ]; then
          echo "telnetd_disable2=$telnetd_disable2" >> $tmpfile
          if [ $telnetd_disable2 = "yes" ]; then
            telnet_stat2="DISABLED"
            pidof telnetd > /dev/null && killall telnetd
          elif [ $otelnetd_disable2 != $telnetd_disable2 ]; then
            /usr/sbin/telnetd
          fi
        fi
        
        rm -f $RC_CONF
        sync
        mv $tmpfile $RC_CONF
        sync

        if [ $oSSH_PORT != $SSH_PORT -o $oSSH_ALLOW_ROOT_LOGIN != $SSH_ALLOW_ROOT_LOGIN ] ; then
          if [ $telnetd_disable != "yes" ]; then
            /disk/dropbear/rc.ssh restart
          fi
        fi

    #fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
 <title>Management Configuration</title>
 <link rel="stylesheet" href="/style.css" type="text/css">
EOT
    if [ "$HTTP_DISABLE" != "true" -a  $oWEBADMIN_PORT != $WEBADMIN_PORT ] ; then
      protocol=http:
      [ $WEBADMIN_PORT = 443 ] && protocol=https:
            
      cat << EOT
 <script language=javascript>

  var countdown = 5;

  function ProgressUpdate()
  {
     countdown--;
     if (countdown >= 0)
     {
        document.getElementById('progress').innerHTML = countdown;
        window.setTimeout("ProgressUpdate()", 1000);
     }
     else
     {
        var host = location.host;
        var i = host.indexOf(":");
        if (i > 0)
        {
           host = host.substring(0, i);
        }
        var url = "$protocol//" + host + ":$WEBADMIN_PORT/";
        top.location = url;
     }
  }

 </script>
</head>
<body onload="ProgressUpdate();">
Reconnecting in <span id="progress">5</span> seconds...<br><br>
EOT
    else
    cat << EOT
</head>
<body>
EOT
    fi
    cat << EOT
<h3>WEB Admin Port: $WEBADMIN_PORT</h3><br>
<h3>WEB (http) is $web_stat</h3><br>
<h3>Secure Shell (ssh) is $telnet_stat</h3><br>
<h3>Telnet Access is $telnet_stat2</h3>
</body>
</html>
EOT
    if [ $oHTTP_DISABLE != $HTTP_DISABLE -o $oWEBADMIN_PORT != $WEBADMIN_PORT ] ; then
      /flash/www/cgi-bin/sleep_http.sh > /dev/null 2>&1 &
    fi
fi
