#!/bin/sh
#
# Copyright (C) 2004-2009 QVidium Technologies, Inc.
#

echo -e "Content-type: text/html\n"

file=/flash/qvidium/snmp_trap.conf
IP_ADDR=""
SNMP_PORT="162"
SNMP_DEV="LAN 1"
COMMUNITY="public"
SEND_TRAPS="0"

[ -f $file ] && . $file

if [ "$QUERY_STRING" = "" ]; then

  TRAPV1_CHECKED=
  TRAPV2_CHECKED=
  if [ "$TRAP_METHOD" = 2 ] ; then
    TRAPV2_CHECKED=checked
  else
    TRAPV1_CHECKED=checked
  fi

  LAN1_CHECKED=
  LAN2_CHECKED=
  if [ "$SNMP_DEV" = 1 ] ; then
    LAN2_CHECKED=checked
  else
    LAN1_CHECKED=checked
  fi

  SEND0_CHECKED=
  SEND1_CHECKED=
  if [ "$SEND_TRAPS" = 0 ] ; then
    SEND0_CHECKED=checked
  else
    SEND1_CHECKED=checked
  fi

  cat << EOT
<html>
<head>
<!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
<title>SNMP Trap Configuration</title>
<link href="/style.css" type="text/css" rel="stylesheet">
<SCRIPT LANGUANG=JAVASCRIPT>
function verify()
{
    if ((document.snmp_form.ipaddr.value == "") &&
        (document.snmp_form.send_traps[0].checked == true))
    {
        alert("Please enter an IP Address");
        return false;
    }
    else
    {
        return true;
    }
}
</SCRIPT>
</head>
<body>
 <h2><center>SNMP Trap Configuration</center></h2>
 <FORM NAME="snmp_form" ACTION="mgmt_snmp_trap.cgi" onSubmit="return verify()">
   <TABLE class=props cellSpacing="1" cellPadding="10" border="1">
    <TR>
      <TD>IP Address:</TD>
      <TD><INPUT TYPE=TEXT NAME="IP_ADDR" size=30 value="$IP_ADDR"></TD>
    </TR>
    <TR>
      <TD>Port:</TD>
      <TD><INPUT TYPE=TEXT NAME="SNMP_PORT" size=30 value="$SNMP_PORT"></TD>
    </TR>
    <TR>
      <TD>Community:</TD>
      <TD><INPUT TYPE=TEXT NAME="COMMUNITY" size=30 value="$COMMUNITY"></TD>
    </TR>
    <TR>
      <TD>SNMP Device:</TD>
      <TD><INPUT TYPE=RADIO NAME="SNMP_DEV" value="0" $LAN1_CHECKED >LAN 1
          <INPUT TYPE=RADIO NAME="SNMP_DEV" value="1" $LAN2_CHECKED >LAN 2
      </TD>
    </TR>
    <TR>
      <TD>Method:</TD>
      <TD><INPUT TYPE=RADIO NAME="TRAP_METHOD" value="1" $TRAPV1_CHECKED >v1 Trap
          <INPUT TYPE=RADIO NAME="TRAP_METHOD" value="2" $TRAPV2_CHECKED >v2c Trap
      </TD>
    </TR>
    <TR>
      <TD>Send Traps:</TD>
      <TD><INPUT TYPE=RADIO NAME="SEND_TRAPS" value="1" $SEND1_CHECKED >Yes
          <INPUT TYPE=RADIO NAME="SEND_TRAPS" value="0" $SEND0_CHECKED >No
      </TD>
    </TR>
   </TABLE>
  <p>
  <INPUT TYPE=SUBMIT VALUE="Change trap configuration">
 </FORM>
</body>
</html>
EOT

else

  eval `./cgiparse "$QUERY_STRING"`

  METHOD_LABEL='v1 Traps'
  [ "$TRAP_METHOD" = 2 ] && METHOD_LABEL='v2c Traps'

  SNMPDEV_LABEL='LAN 1'
  [ "$SNMP_DEV" = 1 ] && SNMPDEV_LABEL='LAN 2'

  SEND_LABEL=Yes
  [ "$SEND_TRAPS" = 0 ] && SEND_LABEL=No

  cat << EOT > $file
IP_ADDR=$IP_ADDR
COMMUNITY="$COMMUNITY"
TRAP_METHOD=$TRAP_METHOD
SEND_TRAPS=$SEND_TRAPS
SNMP_PORT=$SNMP_PORT
SNMP_DEV="$SNMP_DEV"
EOT

  cat << EOT
<html>
<head>
<!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
<title>SNMP Trap Configuration</title>
<link href="/style.css" type="text/css" rel="stylesheet">
</head>
<body>
<p>IP Address: <strong>$IP_ADDR</strong><br>
Port: <strong>$SNMP_PORT</strong><br>
Community: <strong>$COMMUNITY</strong><br>
Method: <strong>$METHOD_LABEL</strong><br>
LAN Device: <strong>$SNMPDEV_LABEL</strong><br>
Send Traps: <strong>$SEND_LABEL</strong><br><p><p>
</body>
</html>
EOT
fi
