#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

# called by network-setup.cgi

# sleep so that html response gets back to web client
sleep 1

mcast_dev=

. /etc/rc.conf

case "$1" in
    *2*)
        dev=eth1
        CONF_FILE=/flash/conf/iflan1
        ;;
    *)
        dev=eth0
        CONF_FILE=/flash/conf/iflan
        ;;
esac

. $CONF_FILE

PID_FILE=/usr/share/udhcpc.$dev.pid
if [ -f $PID_FILE ] ; then
    kill `cat $PID_FILE`
    rm $PID_FILE
fi

if [ "$type" = "udhcp" ]; then
    HOSTNAME=
    [ "$hostname" != "" ] && HOSTNAME="-H $hostname"
    udhcpc $HOSTNAME -i $dev -p $PID_FILE -b
else
    ifconfig $dev down
    ifconfig $dev $ip netmask $nm up
    route del default $dev > /dev/null 2>&1
    if [ "$gw" != "" ]; then
        route add default gw $gw $dev
    fi
fi

[ "$mcast_dev" = "" -a "$dev" = "eth0" ] && mcast_dev=$dev
    
# Setup multicast route
if [ "$dev" = "$mcast_dev" ] ; then
    # Delete any multicast route
    route del -net 224.0.0.0 netmask 240.0.0.0 > /dev/null 2>&1
                                        
    # Setup multicast route
    route add -net 224.0.0.0 netmask 240.0.0.0 dev $mcast_dev
fi

hostname $hostname
echo "127.0.0.1 `hostname`      localhost" > /etc/hosts

# Send out gratuitous ARP reply
eval `/qvidium/etheraddr $dev`
/qvidium/send_arp $IP_ADDR $MAC_ADDR $BROADCAST ff:ff:ff:ff:ff:ff $dev

# Restart ifconfig_server on mcast_dev
pidof ifconfig_server > /dev/null && killall ifconfig_server
#/qvidium/ifconfig_server -i $mcast_dev > /dev/null 2>&1 &
/qvidium/ifconfig_server -i $mcast_dev

exit 0
