#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

. /etc/rc.conf

case "$SCRIPT_NAME" in
    *2*)
        NUM=2
        CONF_FILE=/flash/conf/iflan1
        ;;
    *)
        NUM=1
        CONF_FILE=/flash/conf/iflan
        ;;
esac

. $CONF_FILE

[ "$USE_DHCP_DNS" = "" ] && USE_DHCP_DNS=1

if [ "$QUERY_STRING" = "" ]; then

  eval `awk -f resolve.awk /etc/resolv.conf`

  if [ "$type" = "udhcp" ] ; then
    td="CHECKED"
  else
    tf="CHECKED"
  fi

  HAS_UDHCPC=0

  [ -f /sbin/udhcpc ] && HAS_UDHCPC=1

cat << EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Configure LAN $NUM</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
<style type="text/css">
<!--
body {
	margin:10px 0px; padding:0px; /* Need to set body margin and padding to get consistency between browsers. */
	text-align:center; /* Hack for IE5/Win */
	}
	
#Content {
	width:550px;
	margin:0px auto; /* Right and left margin widths set to "auto" */
	text-align:left; /* Counteract to IE5/Win Hack */
	padding:10px;
	border: ridge 3px;
	border-color: white;
	background-color:rgb(212,208,200);
	}
 label
 {
  width: 13em;
  float: left;
  text-align: left;
  margin-left: 0.5em;
  display: block
 }
 .idented
 {
  margin: 0em;
  padding: 1em 0px 0px 1.30em;
 }
 fieldset
 {
  margin: .25em;
  padding: .25em;
  width: 26em;
 }
 legend
 {
  margin: 0em;
  padding: 0px .25em
 }
--></style>
<script language="javascript"> 
<!--
  function Init()
  {
    CheckIPSettings();
    CheckDNS();
  }

  function CheckIPSettings()
  {
    //alert("document.network.type[0].checked "+ document.network.type[0].checked);
    if (document.network.type[0].checked == true) 
    {
      document.network.ip.disabled = true;
      document.network.nm.disabled = true;
      document.network.gw.disabled = true;
      LABEL1.disabled = true;
      LABEL2.disabled = true;
      LABEL3.disabled = true;
      document.network.USE_DHCP_DNS[0].disabled = false;
      INPUT1.disabled = false;
    }
    else
    {
      document.network.ip.disabled = false;
      document.network.nm.disabled = false;
      document.network.gw.disabled = false;
      document.network.USE_DHCP_DNS[0].checked = false;
      document.network.USE_DHCP_DNS[1].checked = true;
      document.network.USE_DHCP_DNS[0].disabled = true;
      LABEL1.disabled = false;
      LABEL2.disabled = false;
      LABEL3.disabled = false;
      INPUT1.disabled = true;
      CheckDNS();
    }
  }

  function CheckDNS()
  {
    //alert("document.network.USE_DHCP_DNS[0].checked "+ document.network.USE_DHCP_DNS[0].checked);
    if (document.network.USE_DHCP_DNS[0].checked == true) 
    {
      document.network.ns1.disabled = true;
      document.network.ns2.disabled = true;
      LABEL4.disabled = true;
      LABEL5.disabled = true;
    }
    else
    {
      document.network.ns1.disabled = false;
      document.network.ns2.disabled = false;
      LABEL4.disabled = false;
      LABEL5.disabled = false;
    }
  }
--></script>

</head>
<body onload="Init();">
<div id="Content">
<h2><center>Configure LAN $NUM</center></h2>
EOF
if [ "$HAS_UDHCPC" = 1 ] ; then
cat << EOF
You can get IP settings assigned automatically if your network supports
this capability. Otherwise, you need to enter the appropriate static IP settings.
 <form name="network" method="get" action="network-setup$NUM.cgi">
  <div class=idented><input name="type" value="udhcp" type="radio" onClick="CheckIPSettings()" $td >Obtain an IP Address automatically (DHCP)</div>
  <fieldset>
    <legend>
      <input name="type" value="fixed" type="radio" onClick="CheckIPSettings()" $tf >Use the following IP Address:
EOF
else
cat << EOF
You need to ask your network administrator for
the appropriate IP settings.
 <form name="network" method="get" action="network-setup.cgi">
  <fieldset>
    <legend>IP Address Settings:
EOF
fi
cat << EOF
    </legend>
    <p>
    <div ID="LABEL1">
      <label for="ip">IP Address:</label>
      <input type="text" id="ip" value="$ip" name="ip" />
    </div>
    <div ID="LABEL2">
      <label for="nm">Subnet mask:</label>
      <input type="text" id="nm" value="$nm" name="nm" />
    </div>
    <div ID="LABEL3">
      <label id="gwL" for="gw">Default gateway:</label>
      <input type="text" id="gw" value="$gw" name="gw" />
    </div>
    <p>
  </fieldset>
EOF

if [ "$HAS_UDHCPC" = 1 ] ; then
  if [ "$USE_DHCP_DNS" = "1" ] ; then
    dns1="CHECKED"
  else
    dns0="CHECKED"
  fi
cat << EOF
  <div ID="INPUT1" class=idented>
    <input name="USE_DHCP_DNS" value="1" type="radio" onClick="CheckDNS();" $dns1 />Obtain DNS server address automatically (DHCP)
  </div>
  <fieldset>
    <legend>
      <input name="USE_DHCP_DNS" value="0" type="radio" onClick="CheckDNS();" $dns0 />Use the following DNS server addresses:
EOF
else
cat << EOF
  <p><fieldset>
    <legend>DNS server addresses:
EOF
fi

cat << EOF
    </legend>
    <p>
    <div ID="LABEL4">
      <label for="ns1">Preferred DNS server:</label>
      <input type="text" value="$ns1" id="ns1" name="ns1" />
    </div>
    <div>
    <div ID="LABEL5">
      <label for="ns2">Alternate DNS server:</label>
      <input type="text" value="$ns2" id="ns2" name="ns2"/>
    </div>
    <p>
  </fieldset>
  <p><input value="Apply" type="submit">
 </form>
</div>
</body>
</html>
EOF

else

  eval `./cgiparse "$QUERY_STRING"`

if [ ! -f /sbin/udhcpc ] ; then
    type=fixed
fi

if [ $NUM = 1 ] ; then
    # Save new configuration & update resolv.conf
    > /etc/resolv.conf
    if [ "$ns1" != "" ] ; then
        echo "nameserver $ns1" >> /etc/resolv.conf
    fi
    if [ "$ns2" != "" ] ; then
        echo "nameserver $ns2" >> /etc/resolv.conf
    fi
fi

cat << EOF > $CONF_FILE
type=$type
ip=$ip
nm=$nm
gw=$gw
gw_LAN=$gw
user=$user
pswd=$pswd
mtu=$mtu
USE_DHCP_DNS=$USE_DHCP_DNS
EOF
  sync

cat << EOF
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Network Configure Status</title>
</head>
<body>
Updating IP configuration. Please update URL in your Browser!<br>
</body>
</html>
EOF

  /flash/www/cgi-bin/network-setup.sh $NUM > /dev/null 2>&1 &
fi

