#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

RC_CONF="/flash/etc/rc.conf"

[ -r $RC_CONF ] && . $RC_CONF
[ "$PING_DISABLE" = "" ] && PING_DISABLE=false

if [ "$QUERY_STRING" = "" ]; then

    if [ "$PING_DISABLE" = "true" ]; then
      dflt_ping_disabled="CHECKED"
      ping_status="Disabled"
    else
      dflt_ping_enabled="CHECKED"
      ping_status="Enabled"
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Ping Response Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
<h2><center>Ping Response Configuration</center></h2>
<form name="mgmt_conf" method="get" action="ping_conf.cgi">
Ping is $ping_status:<br><br>
  <table class=props id="LogLevel" cellSpacing="1" cellPadding="5" border="1">
    <tbody>
      <tr align="left">
        <td>Ping Access</td>
        <td>
          <input name="PING_DISABLE" type="radio" value="false" $dflt_ping_enabled>Enable 
          <input name="PING_DISABLE" type="radio" value="true" $dflt_ping_disabled>Disable
        </td>
      </tr>
    </tbody>
  </table>
  <input value="Apply" type="submit">
</form>
</body>
</html>
EOT

else
    oPING_DISABLE=$PING_DISABLE

    eval `./cgiparse "$QUERY_STRING"`

    ping_stat="ENABLED"
    [ $PING_DISABLE = "true" ] && ping_stat="DISABLED"

    if [ $oPING_DISABLE != $PING_DISABLE ]; then
        # Delete old PING_DISABLE
        tmpfile="/tmp/rc_conf.$$"
        sed -e '/PING_DISABLE/d' $RC_CONF > $tmpfile

        # Add new settings
        echo "PING_DISABLE=$PING_DISABLE" >> $tmpfile

        if [ $PING_DISABLE = true ] ; then
            sysctl -w net.ipv4.icmp_echo_ignore_all=1 > /dev/null
        else
            sysctl -w net.ipv4.icmp_echo_ignore_all=0 > /dev/null
        fi
        rm -f $RC_CONF
        sync
        mv $tmpfile $RC_CONF
        sync
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Ping Response Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
EOT
    cat << EOT
<h3>Ping is $ping_stat</h3><br><br>
</body>
</html>
EOT

fi
