#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

SYSLOG_CONF=/flash/qvidium/syslog.conf

if [ "$QUERY_STRING" = "" ]; then

    [ -r $SYSLOG_CONF ] && . $SYSLOG_CONF

    syslog_enable_checked=
    if [ "$syslog_enable" = 1 ] ; then
        syslog_enable_checked=checked
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Syslog Configuration</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
  <h2><center>Syslog Configuration</center></h2>
<form action="/cgi-bin/syslog_conf.cgi" method="get" name="syslog_server">
  <table class=props border="1" cellspacing="1"  cellPadding="5" >
    <tr>
      <td nowrap>Enable Syslog</td>
      <td nowrap>
        <input type="checkbox" name="syslog_enable" value="1" $syslog_enable_checked>Yes
      </td>
    </tr>
    <tr>
      <td nowrap>Server IP</td>
      <td nowrap>
        <input type="text" name="syslog_ip" size="40" maxlength="40" value="$syslog_ip">
      </td>
    </tr>
  </table>
  <p>
  <input value="Set Syslog Server" type="submit" name="SYSLOG">
</form>
</body>
</html>
EOT
else
    eval `./cgiparse "$QUERY_STRING"`

    msg=
    [ "$syslog_enable" = "" ] && syslog_enable=0
    [ "$syslog_ip" = "" ] && syslog_ip="0.0.0.0"

    killall syslogd > /dev/null 2>&1
    cat << EOT > $SYSLOG_CONF
syslog_enable=$syslog_enable
syslog_ip=$syslog_ip
EOT
    if [ "$syslog_enable" = 1 ] ; then
        if [ "$syslog_ip" = 0.0.0.0 ] ; then
            msg="Server IP not set, Syslog not started"
        else
            syslogd -R $syslog_ip > /var/log/syslog.log 2>&1
            if pidof syslogd > /dev/null ; then
                msg="Syslog started"
            else
                msg="ERROR: Syslog did not start"
            fi
        fi
    else
        msg="Syslog stopped"
    fi

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>Syslog Results</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
  <h2><center>Syslog Results</center></h2>
  $msg
</body>
</html>
EOT

fi

