#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc.

echo -e "Content-type: text/html\n"

if [ "$QUERY_STRING"x = x ]; then

    date +"%Y %m %d %H %M %S" > /tmp/tmp.$$
    read year mon day hr min sec < /tmp/tmp.$$
    rm -f /tmp/tmp.$$

    . /etc/rc.conf

    #if [ "$ntp_update_interval" = "" ] ; then
        ntp_update_interval=5
    #fi

    ntp_enable_checked=
    if [ "$ntpc_enable" = 1 ] ; then
        ntp_enable_checked=checked
    fi

    tz=`cat /etc/TZ`
    now=`date -R`
    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>NTP Setup</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
<h2><center>Date/Time/NTP</center></h2>
<b>Current time: $now</b><p>
Date and Time Settings<br>
<form action="/cgi-bin/system_time.cgi" method="get" name="time">
  <table class=props border="1" cellspacing="1"  cellPadding="5" >
    <tr>
      <td rowspan=2 nowrap>Local Time</td>
      <td>Yr [YYYY]</td>
      <td>Mon [MM]</td>
      <td>Day [DD]</td>
      <td>Hr [hh]</td>
      <td>Min [mm]</td>
      <td>Sec [ss]</td>
    </tr>
    <tr>
      <td><input type="text" name="YEAR" size="4" maxlength="4" value=$year></td>
      <td><input type="text" name="MON"  size="2" maxlength="2" value=$mon></td>
      <td><input type="text" name="DAY"  size="2" maxlength="2" value=$day></td>
      <td><input type="text" name="HOUR" size="2" maxlength="2" value=$hr></td>
      <td><input type="text" name="MIN"  size="2" maxlength="2" value=$min></td>
      <td><input type="text" name="SEC"  size="2" maxlength="2" value=$sec></td>
    </tr>
  </table>
  <p>
  <input value="Set Date and Time" type="submit" name="DATETIME">
</form>

<hr>
<p>NTP Time Server<br>
<form action="/cgi-bin/system_time.cgi" method="get" name="ntp_server">
  <table class=props border="1" cellspacing="1"  cellPadding="5" >
    <tr>
      <td width="120" nowrap>NTP Functionality</td>
      <td nowrap>
        <input type="checkbox" name="ntpc_enable" value="1" $ntp_enable_checked>Enable
      </td>
    </tr>
    <tr>
      <td width="120" nowrap>Server IP</td>
      <td nowrap>
        <input type="text" name="ntp_host_ip" size="40" maxlength="255" value="$ntp_host_ip">
      </td>
    </tr>
    <!--
    <tr>
      <td width="120" nowrap>Update Interval</td>
      <td nowrap>
        <input type="text" name="ntp_update_interval" size="10" maxlength="2" value="$ntp_update_interval"> minutes (1 to 59)
      </td>
    </tr>
    -->
  </table>
  <p>
  <input value="Set NTP Time Server" type="submit" name="NTP">
</form>

<hr>
<p>Time Zone<br>
<form action="/cgi-bin/system_time.cgi" method="get" name="tz">
  <table class=props border="1" cellspacing="1"  cellPadding="5" >
    <tr>
      <td width="120" nowrap>Time Zone</td>
      <td nowrap>
        <select size="1" name="tz">
EOT

    case "$tz" in
      *+00) tz_value=$tz ;;
      *-*) tz_value=`echo "$tz" | sed 's/-/+/'` ;;
      *) tz_value=`echo "$tz" | sed 's/+/-/'` ;;
    esac

    for i in -12 -11 -10 -09 -08 -07 -06 -05 -04 -03 -02 -01 +00 +01 +02 +03 +04 +05 +06 +07 +08 +09 +10 +11 +12 +13
    do
        selected=
        if [ "$tz_value" = "GMT${i}" ] ; then
            selected=selected
        fi
        echo '<option  value="GMT'${i}'"' $selected'>GMT'${i}':00</option>'
    done

    cat << EOT
        </select>
      </td>
    </tr>
  </table>
  <p>
  <input value="Set Time Zone" type="submit" name="TIMEZONE">

</form>
</body>
</html>
EOT
else
    eval `./cgiparse "$QUERY_STRING"`

    msg1=
    msg2=
    RC_CONF="/flash/etc/rc.conf"
    if [ "$TIMEZONE" != "" ] ; then
        tz_tmp=`echo $tz | sed 's/ /+/'`
        case "$tz_tmp" in
          *+00) tz_value=$tz_tmp ;;
          *-*) tz_value=`echo "$tz_tmp" | sed 's/-/+/'` ;;
          *) tz_value=`echo "$tz_tmp" | sed 's/+/-/'` ;;
        esac
        echo $tz_value > /etc/TZ
    elif [ "$DATETIME" != "" ] ; then
        . $RC_CONF
        if [ "$ntpc_enable" = 1 ] ; then
            msg1="Can not set date and time since NTP is enabled"
        else
            msg1=`date "$MON$DAY$HOUR$MIN$YEAR.$SEC" 2>&1`
        fi
    else
        [ "$ntpc_enable" = "" ] && ntpc_enable=0
        [ "$ntp_host_ip" = "" ] && ntp_host_ip="0.0.0.0"
        #[ "$ntp_update_interval" = "" ] && ntp_update_interval=5

        #test "$ntp_update_interval" -gt 0 -a "$ntp_update_interval" -lt 60 2> /dev/null
        #if [ $? != 0 ] ; then
            ntp_update_interval=5
        #fi

        TMP="/tmp/rc.conf.$$"

        killall crond > /dev/null 2>&1
        sed "/ntpc_enable/d;/ntp_host_ip/d;/ntp_update_interval/d" $RC_CONF > $TMP
        cat << EOT >> $TMP
ntpc_enable=$ntpc_enable
ntp_host_ip=$ntp_host_ip
ntp_update_interval=$ntp_update_interval
EOT
        cp $TMP $RC_CONF
        rm -f $TMP

        if [ "$ntpc_enable" = 1 ] ; then
            if [ "$ntp_host_ip" = 0.0.0.0 ] ; then
                msg2="Server IP not set, NTP time not updated"
            else
                msg2=`/sbin/ntpdate $ntp_host_ip`
                echo "0-59/$ntp_update_interval * * * * /sbin/ntpdate $ntp_host_ip" > /etc/root
                /usr/sbin/crond -c /etc
            fi
        else
            rm -f /etc/root
        fi
    fi

    cur_time=`date -R`
    hwclock -w -u

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>Date/Time/NTP Results</title>
  <link rel="stylesheet" href="/style.css" type="text/css">
</head>
<body>
  <h2><center>Date/Time/NTP Results</center></h2>
EOT
    if [ "$msg1" != "" ] ; then
        echo "Date results: $msg1<br><br>"
    fi
    if [ "$msg2" != "" ] ; then
        echo "NTP results: $msg2<br><br>"
    fi
    cat << EOT
<p>Current Time: $cur_time
</body>
</html>
EOT

fi

