#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

DONE=/tmp/update.done

if [ -r $DONE ] ; then
  refresh=
  err=`cat $DONE`
else
  refresh="<meta http-equiv=\"Refresh\" content=\"1\">"
  err=3
fi

echo -e "Content-type: text/html\n"

cat << ENDOFTEXT
<HTML>
<HEAD>
<link rel="stylesheet" href="/style.css" type="text/css">
$refresh
<TITLE>Update Results</TITLE>
</HEAD>
<BODY>
<H2><CENTER>Update Results</CENTER></H2>
ENDOFTEXT

if [ ! -r /tmp/update.status ] ; then
  if [ "$REQUEST_METHOD" = "POST" ] ; then
    echo "Updating...<br>" > /tmp/update.status
    # parse MIME format stdin and save file to /tmp/qvidium.lic
    FILE=/tmp/qvidium.pkg
    ./getfile > $FILE
    SIZE=`ls -l $FILE | awk '{print $5}'`
    if [ $SIZE -gt 1000000 ] ; then
        TMP=/disk/tmp
        [ ! -d $TMP ] && mkdir $TMP
        cd $TMP
        tar xf $FILE >> /tmp/update.status 2>&1
        RC=$?
        if [ $RC = 0 ] ; then
            rm -f $FILE
            sync;sync;sync
            mv $TMP/* /tmp
            sync;sync;sync
            cd /tmp
            rm -rf $TMP
            sync;sync;sync
        fi
    else
        cd /tmp
        tar xf $FILE >> /tmp/update.status 2>&1
        RC=$?
    fi
    if [ $RC = 0 ] ; then
        if [ -f install.sh ] ; then
            ./install.sh >> /tmp/update.status 2>&1 &
        else
            echo "Not an update file<br>" >> /tmp/update.status
        fi
    fi
  else
    echo "Something when wrong: REQUEST_METHOD = $REQUEST_METHOD<br>REQUEST_METHOD should be POST<br>" >> /tmp/update.status
  fi
else
  if [ $err -eq 0 ] ; then
    echo "Please reboot or cycle power<br>"
  elif [ $err -eq 1 ] ; then
    echo "Check file and try again<br>"
  elif [ $err -eq 2 ] ; then
    echo "Call technical support<br>"
  fi
fi

cat /tmp/update.status

cat << ENDOFTEXT
</BODY>
</HTML>
ENDOFTEXT

