#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

echo -e "Content-type: text/html\n"

CONF_FILE=/flash/qvidium/transcode/profile

if [ "$QUERY_STRING" = "" ]; then

    HAS_SDI=false
    [ -f /flash/qvidium/inputs.conf ] && . /flash/qvidium/inputs.conf
    [ "$HAS_SDI" = "" ] && HAS_SDI=false

    PROGRAM=Auto
    PROFILE=auto
    LEVEL=auto
    SRC_TRANSPORT=UDP
    SRC_MULTICAST_IPADDR=
    SRC_UDP_PORT=10000
    NETWORK_JITTER=50
    OUT_OF_ORDER_SIZE=0
    RESPONSE=250
    BURST_DROP=40
    ROBUST=1
    NUM_RETRIES=2
    RT_TIME=100
    ARQ_MODE=Auto
    ARQ_PORT=7020
    PING_SENDER=0
    SERVER_IPADDR=
    ECHO_PORT=7
    MODE="IP to IP"
    DETECT_VIDEO_CHANGE=yes
    DETECT_VIDEO_MS=150
    VIDEO_ENCODING=H264
    VIDEO_RES=720x480
    VIDEO_BITRATE=2000000
    AUDIO_ENCODING="Pass Through"
    DEST_TRANSPORT=UDP
    DEST_IPADDR_OR_HOSTNAME=
    DEST_UDP_PORT=20000
    DEST_ARQ_PORT=8020
    NUM_TS_PKTS_PER_IP_PKT=7
    USE_PACING=0
    UNI_TTL=128
    M_TTL=64
    TOS=0

    [ -f $CONF_FILE ] && . $CONF_FILE

    [ "$SRC_UDP_PORT" = "" ] && SRC_UDP_PORT=10000
    [ "$ARQ_PORT" = "" ] && ARQ_PORT=7020
    [ "$VIDEO_BITRATE" = "" ] && VIDEO_BITRATE=2000000
    [ "$NUM_TS_PKTS_PER_IP_PKT" = "" ] && NUM_TS_PKTS_PER_IP_PKT=7
    [ "$UNI_TTL" = "" ] && UNI_TTL=128
    [ "$M_TTL" = "" ] && M_TTL=64
    [ "$PROGRAM" = "" ] && PROGRAM=Auto

    PROGRAM_0_Selected=
    PROGRAM_1_Selected=
    PROGRAM_2_Selected=
    PROGRAM_3_Selected=
    PROGRAM_4_Selected=
    PROGRAM_5_Selected=
    PROGRAM_6_Selected=
    PROGRAM_7_Selected=
    PROGRAM_8_Selected=
    PROGRAM_9_Selected=
    PROGRAM_10_Selected=
    case "$PROGRAM" in
         1) PROGRAM_1_Selected=selected ;;
         2) PROGRAM_2_Selected=selected ;;
         3) PROGRAM_3_Selected=selected ;;
         4) PROGRAM_4_Selected=selected ;;
         5) PROGRAM_5_Selected=selected ;;
         6) PROGRAM_6_Selected=selected ;;
         7) PROGRAM_7_Selected=selected ;;
         8) PROGRAM_8_Selected=selected ;;
         9) PROGRAM_9_Selected=selected ;;
        10) PROGRAM_10_Selected=selected ;;
         *) PROGRAM_0_Selected=selected ;;
    esac

    PROFILE_B_Selected=
    PROFILE_M_Selected=
    PROFILE_H_Selected=
    PROFILE_A_Selected=
    case "$PROFILE" in
        Base) PROFILE_B_Selected=selected ;;
        Main) PROFILE_M_Selected=selected ;;
        High) PROFILE_H_Selected=selected ;;
           *) PROFILE_A_Selected=selected ;;
    esac

    LEVEL_12_Selected=
    LEVEL_20_Selected=
    LEVEL_21_Selected=
    LEVEL_22_Selected=
    LEVEL_30_Selected=
    LEVEL_31_Selected=
    LEVEL_32_Selected=
    LEVEL_40_Selected=
    LEVEL_41_Selected=
    LEVEL_A_Selected=
    case "$LEVEL" in
        1.2) LEVEL_12_Selected=selected ;;
        2.0) LEVEL_20_Selected=selected ;;
        2.1) LEVEL_21_Selected=selected ;;
        2.2) LEVEL_22_Selected=selected ;;
        3.0) LEVEL_30_Selected=selected ;;
        3.1) LEVEL_31_Selected=selected ;;
        3.2) LEVEL_32_Selected=selected ;;
        4.0) LEVEL_40_Selected=selected ;;
        4.1) LEVEL_41_Selected=selected ;;
          *) LEVEL_A_Selected=selected ;;
    esac
 
    MPEG2_Selected=
    MPEG4_Selected=
    H264_Selected=
    MPEG2_CBR_Selected=
    H264_CBR_Selected=
    case "$VIDEO_ENCODING" in
        MPEG2) MPEG2_Selected=selected ;;
        #MPEG4) MPEG4_Selected=selected ;;
        MPEG2*C*) MPEG2_CBR_Selected=selected ;;
        H264*C*) H264_CBR_Selected=selected ;;
        *) H264_Selected=selected ;;
    esac

    AUD_MPEG4_Selected=
    AUD_MPEG2_Selected=
    AUD_MPEG1_Selected=
    AUD_PASSTHRU_Selected=
    case "$AUDIO_ENCODING" in
         Pass*) AUD_PASSTHRU_Selected=selected ;;
        MPEG1*) AUD_MPEG1_Selected=selected ;;
        MPEG2*) AUD_MPEG2_Selected=selected ;;
             *) AUD_MPEG4_Selected=selected ;;
    esac

    [ $HAS_SDI = false ] && MODE="IP to IP"
    IP2IP_Selected=
    IP2ASI_Selected=
    ASI2IP_Selected=
    ASI2ASI_Selected=
    case "$MODE" in
      ASI*ASI) ASI2ASI_Selected=selected ;;
      ASI*IP)  ASI2IP_Selected=selected ;;
      IP*ASI)  IP2ASI_Selected=selected ;;
      *)       IP2IP_Selected=selected ;;
    esac
    
    VID_default_Selected=
    VID_1440x1080_Selected=
    VID_720x480_Selected=
    VID_720x576_Selected=
    VID_352x480_Selected=
    VID_352x576_Selected=
    VID_352x240_Selected=
    VID_352x288_Selected=
    case "$VIDEO_RES" in
        352x240)   VID_352x240_Selected=selected ;;
        352x288)   VID_352x288_Selected=selected ;;
        #352x480)   VID_352x480_Selected=selected ;;
        #352x576)   VID_352x576_Selected=selected ;;
        720x480)   VID_720x480_Selected=selected ;;
        720x576)   VID_720x576_Selected=selected ;;
        1440x1080) VID_1440x1080_Selected=selected ;;
              *)   VID_default_Selected=selected ;;
    esac

    PING0_CHECKED=
    PING1_CHECKED=
    case "$PING_SENDER" in
        1) PING1_CHECKED=checked ;;
        *) PING0_CHECKED=checked ;;
    esac

    PACING0_CHECKED=
    PACING1_CHECKED=
    case "$USE_PACING" in
        1) PACING1_CHECKED=checked ;;
        *) PACING0_CHECKED=checked ;;
    esac

    SRC_ENC_ARQ_Selected=
    SRC_ENC_RTP_Selected=
    SRC_ENC_UDP_Selected=
    case "$SRC_TRANSPORT" in
        RTP) SRC_ENC_RTP_Selected=selected ;;
        ARQ) SRC_ENC_ARQ_Selected=selected ;;
        *) SRC_ENC_UDP_Selected=selected ;;
    esac

    DST_ENC_ARQ_Selected=
    DST_ENC_RTP_Selected=
    DST_ENC_UDP_Selected=
    DST_ENC_RTSP_Selected=
    case "$DEST_TRANSPORT" in
        #RTSP) DST_ENC_RTSP_Selected=selected ;;
         RTP) DST_ENC_RTP_Selected=selected ;;
         ARQ) DST_ENC_ARQ_Selected=selected ;;
           *) DST_ENC_UDP_Selected=selected ;;
    esac

    [ "$DETECT_VIDEO_MS"x = x ] && DETECT_VIDEO_MS=150

    DETECT_VID_YES_Selected=
    DETECT_VID_NO_Selected=
    if [ "$DETECT_VIDEO_CHANGE" = yes ] ; then
        DETECT_VID_YES_Selected=selected
    else
        DETECT_VID_NO_Selected=selected
    fi

    robustcheck=
    [ "$ROBUST" = 1 ] && robustcheck=checked

    ARQ_AUTO_Selected=
    ARQ_MANUAL_Selected=
    case "$ARQ_MODE" in
        Manual) ARQ_MANUAL_Selected=selected ;;
        *) ARQ_AUTO_Selected=selected ;;
    esac

    cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>Video Setup</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
  <link href="/tabbed_panel.css" type="text/css" rel="stylesheet">
  <SCRIPT LANGUAGE=JAVASCRIPT>

  function IsNumeric(str) {
    var ValidChars = "0123456789";
    var Char;

    for (i = 0; i < str.length; i++) {
      Char = str.charAt(i);
      if (ValidChars.indexOf(Char) == -1) return false;
    }
    return true;
  }

  function ManageTabPanelDisplay() {
    //
    // Between the parenthesis, list the id's of the div's that
    //     will be effected when tabs are clicked. List in any
    //     order. Put the id's in single quotes (apostrophes)
    //     and separate them with a comma -- all one line.
    //
    var idlist = new Array(
            'tab1focus','tab2focus','tab3focus','tab4focus','tab5focus',
            'tab1ready','tab2ready','tab3ready','tab4ready','tab5ready',
            'content1', 'content2', 'content3', 'content4', 'content5');

    if (arguments.length < 1) { return; }
    for (var i = 0; i < idlist.length; i++) {
      var block = false;
      for (var ii = 0; ii < arguments.length; ii++) {
        if (idlist[i] == arguments[ii]) {
          block = true;
          break;
        }
      }
      if (block) {
        document.getElementById(idlist[i]).style.display = "block";
      }
      else {
        document.getElementById(idlist[i]).style.display = "none";
      }
    }
  }

  // whichTest = 0 means test uni-cast
  // whichTest = 1 means test multi-cast
  function verifyIP (IPvalue, whichTest) {
    errorString = "";
    theName = "IPaddress";

    var ipArray = IPvalue.match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);

    if (IPvalue == null || IPvalue == "") {
      return true;
    }

    if (IPvalue == "0.0.0.0")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    else if (IPvalue == "255.255.255.255")
      errorString = errorString + theName + ': '+IPvalue+' is a special IP address and cannot be used here.';
    if (ipArray == null)
      errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
    else {
      for (i = 1; i < 5; i++) {
        thisSegment = ipArray[i];
        if (thisSegment > 255) {
          errorString = errorString + theName + ': '+IPvalue+' is not a valid IP address.';
          i = 5;
        }
        if (i == 1) {
          if (whichTest == 0) {
            if (thisSegment >= 224) {
              errorString = errorString + theName + ': '+IPvalue+' is not a valid uni-cast IP address.';
              i = 5;
            }
          }
          else if (whichTest == 1) {
            if ((thisSegment < 224) || (thisSegment > 239)) {
              errorString = errorString + theName + ': '+IPvalue+' is not a valid multicast address .';
              i = 5;
            }
          }
        }
      }
    }
    extensionLength = 3;
    if (errorString != "") {
      alert (errorString);
      return false;
    }
    return true;
  }

  function verify()
  {
    var mCastAddr = document.forms[0].SRC_MULTICAST_IPADDR.value;
    if (verifyIP(mCastAddr, 1) == false) return false;

    var tmp;
    var tmp2;

    tmp = document.forms[0].SRC_UDP_PORT.value;
    if (IsNumeric(tmp) == false || tmp < 1 || tmp > 65535) {
      alert('Source UDP Port "'+tmp+'" is not valid [1,65535].');
      return false;
    }
    tmp = document.forms[0].DETECT_VIDEO_MS.value;
    if (IsNumeric(tmp) == false || tmp < 100 || tmp > 2000) {
      alert('Detect Video Break "'+tmp+'" is not valid [100,2000].');
      return false;
    }
    tmp = document.forms[0].NETWORK_JITTER.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 3000) {
      alert('Jitter "'+tmp+'" is not valid [0,3000].');
      return false;
    }
    //tmp = document.forms[0].OUT_OF_ORDER_SIZE.value;
    //if (IsNumeric(tmp) == false || tmp < 0 || tmp > 100) {
    //  alert('Out Of order "'+tmp+'" is not valid [0,100].');
    //  return false;
    //}
    tmp = document.forms[0].RESPONSE.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 3000) {
      alert('Target Latency "'+tmp+'" is not valid [0,3000].');
      return false;
    }
    tmp2 = document.forms[0].BURST_DROP.value;
    if (IsNumeric(tmp2) == false || tmp2 < 0 || tmp2 > 1000) {
      alert('Burst drop "'+tmp2+'" is not valid [0,1000].');
      return false;
    }
    var a = new Number(tmp2);
    var b = new Number(tmp);
    if (a >= b) {
      alert('Burst drop "'+tmp2+'" must be less than Target Latency ('+tmp+').');
      return false;
    }
    tmp = document.forms[0].NUM_RETRIES.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 10) {
      alert('Number Retries "'+tmp+'" is not valid [0,10].');
      return false;
    }
    tmp = document.forms[0].RT_TIME.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 2000) {
      alert('Jitter "'+tmp+'" is not valid [0,2000].');
      return false;
    }
    tmp = document.forms[0].ECHO_PORT.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 65535) {
      alert('Echo Port "'+tmp+'" is not valid [0,65535].');
      return false;
    }
    tmp = document.forms[0].ARQ_PORT.value;
    if (IsNumeric(tmp) == false || tmp < 0 || tmp > 65535) {
      alert('ARQ Port "'+tmp+'" is not valid [0,63353].');
      return false;
    }

    //var IPAddr = document.forms[0].SERVER_IPADDR.value;
    //if (verifyIP(IPAddr, 0) == false) return false;

    return true;
  }
  </SCRIPT>
</head>
<body>
 <h2><center>Transcode Profile</center></h2>
 <p>
 <b><a href="/TranscodeProfile.html" target="_blank">Press here for Help</a></b>
 <p>
  <form name="video" method="get" action="transcode-setup.cgi" onSubmit="return verify()">

    <table width=600 style="border-collapse:collapse;" border="0" cellpadding="0" cellspacing="0">
     <tr>
       <td>
         <div id="tab1focus" class="tab tabfocus" style="display:block;">
           Transcode
         </div>
         <div id="tab1ready" class="tab tabhold" style="display:none;">
           <span onclick="ManageTabPanelDisplay('tab1focus','tab2ready','tab3ready','tab4ready','tab5ready','content1')">Transcode</span>
         </div>
       </td>
       <td width="5"> </td>
       <td>
         <div id="tab2focus" class="tab tabfocus" style="display:none;">
           Network In
         </div>
         <div id="tab2ready" class="tab tabhold" style="display:block;">
           <span onclick="ManageTabPanelDisplay('tab1ready','tab2focus','tab3ready','tab4ready','tab5ready','content2')">Network In</span>
         </div>
       </td>
       <td width="5"> </td>
       <td>
         <div id="tab3focus" class="tab tabfocus" style="display:none;">
           ARQ In
         </div>
         <div id="tab3ready" class="tab tabhold" style="display:block;">
           <span onclick="ManageTabPanelDisplay('tab1ready','tab2ready','tab3focus','tab4ready','tab5ready','content3')">ARQ In</span>
         </div>
       </td>
       <td width="5"> </td>
       <td>
         <div id="tab4focus" class="tab tabfocus" style="display:none;">
           Server
         </div>
         <div id="tab4ready" class="tab tabhold" style="display:block;">
           <span onclick="ManageTabPanelDisplay('tab1ready','tab2ready','tab3ready','tab4focus','tab5ready','content4')">Server</span>
         </div>
       </td>
       <td width="5"> </td>
       <td>
         <div id="tab5focus" class="tab tabfocus" style="display:none;">
           Network Out
         </div>
         <div id="tab5ready" class="tab tabhold" style="display:block;">
           <span onclick="ManageTabPanelDisplay('tab1ready','tab2ready','tab3ready','tab4ready','tab5focus','content5')">Network Out</span>
         </div>
       </td>
       <td class="tabspace" width="30"> </td>
     </tr>
     <tr>
       <td colspan="10">

         <!--  Transcode Parameters -->
         <div id="content1" class="tabcontent" style="display:block;">
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr>
             <td>Program</td>
             <td>
              <select name="PROGRAM">
               <option $PROGRAM_0_Selected>Auto</option>
               <option $PROGRAM_1_Selected>1</option>
               <option $PROGRAM_2_Selected>2</option>
               <option $PROGRAM_3_Selected>3</option>
               <option $PROGRAM_4_Selected>4</option>
               <option $PROGRAM_5_Selected>5</option>
               <option $PROGRAM_6_Selected>6</option>
               <option $PROGRAM_7_Selected>7</option>
               <option $PROGRAM_8_Selected>8</option>
               <option $PROGRAM_9_Selected>9</option>
               <option $PROGRAM_10_Selected>10</option>
              </select>
             </td>
            </tr>
EOT
    if [ $HAS_SDI != false ] ; then
        cat << EOT
            <tr>
             <td>Mode</td>
             <td>
              <select name="MODE">
               <option $IP2IP_Selected>IP to IP</option>
               <option $IP2ASI_Selected>IP to ASI</option>
               <option $ASI2IP_Selected>ASI to IP</option>
               <option $ASI2ASI_Selected>ASI to ASI</option>
              </select>
             </td>
            </tr>
EOT
    fi
cat << EOT
            <tr align="left">
             <td>Video Bit Rate<br></td>
             <td><input name="VIDEO_BITRATE" size="8" maxlength="8" value="$VIDEO_BITRATE" type="text"></td>
            </tr>
            <tr>
             <td>Video Encoding</td>
             <td>
              <select name="VIDEO_ENCODING">
               <option $H264_Selected>H264</option>
               <option $MPEG2_Selected>MPEG2</option>
               <option $H264_CBR_Selected>H264 Constant Quantization</option>
               <option $MPEG2_CBR_Selected>MPEG2 Constant Quantization</option>
               <!--
               <option $MPEG4_Selected>MPEG4</option>
               -->
              </select>
             </td>
            </tr>
            <tr>
             <td>Video Resolution</td>
             <td>
              <select name="VIDEO_RES">
               <option $VID_default_Selected>auto</option>
               <option $VID_1440x1080_Selected>1440x1080</option>
               <option $VID_720x480_Selected>720x480</option>
               <option $VID_720x576_Selected>720x576</option>
               <!--
               <option $VID_352x480_Selected>352x480</option>
               <option $VID_352x576_Selected>352x576</option>
               -->
               <option $VID_352x240_Selected>352x240</option>
               <option $VID_352x288_Selected>352x288</option>
              </select>
             </td>
            </tr>
            <tr>
             <td>Audio Encoding</td>
             <td>
              <select name="AUDIO_ENCODING">
               <option $AUD_MPEG4_Selected>MPEG4 AAC</option>
               <option $AUD_MPEG2_Selected>MPEG2 AAC</option>
               <option $AUD_MPEG1_Selected>MPEG1 Layer2</option>
               <option $AUD_PASSTHRU_Selected>Pass Through</option>
              </select>
             </td>
            </tr>
            <tr>
             <td>MPEG4 Profile</td>
             <td>
              <select name="PROFILE">
               <option $PROFILE_B_Selected>Base</option>
               <option $PROFILE_M_Selected>Main</option>
               <option $PROFILE_H_Selected>High</option>
               <option $PROFILE_A_Selected>auto</option>
              </select>
             </td>
            </tr>
            <tr>
             <td>MPEG4 Level</td>
             <td>
              <select name="LEVEL">
               <option $LEVEL_12_Selected>1.2</option>
               <option $LEVEL_20_Selected>2.0</option>
               <option $LEVEL_21_Selected>2.1</option>
               <option $LEVEL_22_Selected>2.2</option>
               <option $LEVEL_30_Selected>3.0</option>
               <option $LEVEL_31_Selected>3.1</option>
               <option $LEVEL_32_Selected>3.2</option>
               <option $LEVEL_40_Selected>4.0</option>
               <option $LEVEL_41_Selected>4.1</option>
               <option $LEVEL_A_Selected>auto</option>
              </select>
             </td>
            </tr>
            <tr align="left">
             <td>Detect video break (network input/output<br> Does not work for ASI output)</td>
             <td>
              <select name="DETECT_VIDEO_CHANGE">
               <option $DETECT_VID_YES_Selected>yes</option>
               <option $DETECT_VID_NO_Selected>no</option>
              </select>
             </td>
            </tr>
            <tr align="left">
             <td>Detect video break limit (100 to 2000 ms)</td>
             <td><input name="DETECT_VIDEO_MS" size="16" maxlength="15" value="$DETECT_VIDEO_MS" type="text"></td>
            </tr>
           </table>
         </div>
            
         <!--  Network In Parameters -->
         <div id="content2" class="tabcontent" style="display:none;">
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr align="left">
             <td>IP Transport</td>
             <td>
              <select name="SRC_TRANSPORT">
               <option $SRC_ENC_ARQ_Selected>ARQ</option>
               <option $SRC_ENC_RTP_Selected>RTP</option>
               <option $SRC_ENC_UDP_Selected>UDP</option>
              </select>
             </td>
            </tr>
            <tr align="left">
             <td>Multicast Address [1]</td>
             <td><input name="SRC_MULTICAST_IPADDR" size="16" maxlength="15" value="$SRC_MULTICAST_IPADDR" type="text"></td>
            </tr>
            <tr align="left">
             <td>UDP Port</td>
             <td><input name="SRC_UDP_PORT" size="16" maxlength="15" value="$SRC_UDP_PORT" type="text"></td>
            </tr>
            <tr align="left">
             <td>Jitter (ms)</td>
             <td><input name="NETWORK_JITTER" size="16" maxlength="15" value="$NETWORK_JITTER" type="text"></td>
            </tr>
            <!-- 
            <tr align="left">
             <td>Out Of Order (#Packets) [2]</td>
             <td><input name="OUT_OF_ORDER_SIZE" size="16" maxlength="15" value="$OUT_OF_ORDER_SIZE" type="text"></td>
            </tr>
            -->
           </table>
           [1] This is not the sender's IP address<br>
            <!-- 
           [2] Additional out of order buffering for ARQ and RTP only
            -->
         </div>

         <!--  ARQ Parameters -->
         <div id="content3" class="tabcontent" style="display:none;">
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr align="left">
             <td>ARQ Port [1]</td>
             <td><input name="ARQ_PORT" size="16" maxlength="15" value="$ARQ_PORT" type="text"></td>
            </tr>
            <tr>
             <td>Mode</td>
             <td>
              <select name="ARQ_MODE">
               <option $ARQ_AUTO_Selected>Auto</option>
               <option $ARQ_MANUAL_Selected>Manual</option>
              </select>
             </td>
            </tr>
            <tr><td colSpan="2">Manual Mode Parameters</td></tr>
            <tr align="left">
             <td>Number Retries</td>
             <td><input name="NUM_RETRIES" size="16" maxlength="15" value="$NUM_RETRIES" type="text"></td>
            </tr>
            <tr align="left">
             <td>Round Trip Time</td>
             <td><input name="RT_TIME" size="16" maxlength="15" value="$RT_TIME" type="text"></td>
            </tr>
            <tr><td colSpan="2">Auto Mode Parameters</td></tr>
            <tr align="left">
             <td>Target Latency (ms)</td>
             <td><input name="RESPONSE" size="16" maxlength="15" value="$RESPONSE" type="text"></td>
            </tr>
            <tr align="left">
             <td>Max Burst Drop (ms) [2]</td>
             <td><input name="BURST_DROP" size="16" maxlength="15" value="$BURST_DROP" type="text"></td>
            </tr>
            <tr align="left">
             <td>Robust Mode</td>
             <td><input type="checkbox" name="ROBUST" value="1" $robustcheck ></td>
            </tr>
           </table>
           [1] Sends resend requests to receiver<br>
           [2] Burst Drop must be less than Target Latency
         </div>

         <!--  Server Parameters -->
         <div id="content4" class="tabcontent" style="display:none;">
           <strong><font size="+1">QVidium Video Server settings.</font></strong>
           <br>
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr>
              <td>Use Server</td>
              <td><input type=radio name="PING_SENDER" value="1" $PING1_CHECKED >Yes
                  <input type=radio name="PING_SENDER" value="0" $PING0_CHECKED >No
              </td>
            </tr>
            <tr>
              <td>IP Address or Hostname</td>
              <td><input name="SERVER_IPADDR" size="40" maxlength="39" value="$SERVER_IPADDR" type="text"></td>
            </tr>
            <tr>
              <td>Echo Port</td>
              <td><input name="ECHO_PORT" size="16" maxlength="15" value="$ECHO_PORT" type=test></td>
            </tr>
           </table>
            Note: Do not enable unless connecting to a QVidium video server.
         </div>

         <!--  Network Out Parameters -->
         <div id="content5" class="tabcontent" style="display:none;">
           <table width=500 class=props border="1" cellpadding="2" cellspacing="1">
            <tr>
             <td>IP Transport</td>
             <td>
              <select name="DEST_TRANSPORT">
               <option $DST_ENC_ARQ_Selected>ARQ</option>
               <option $DST_ENC_RTP_Selected>RTP</option>
               <option $DST_ENC_UDP_Selected>UDP</option>
               <!--
               <option $DST_ENC_RTSP_Selected>RTSP</option>
               -->
              </select>
             </td>
            </tr>
            <tr align="left">
             <td>Destination IP or Multicast Address</td>
             <td><input name="DEST_IPADDR_OR_HOSTNAME" size="40" maxlength="39" value="$DEST_IPADDR_OR_HOSTNAME" type="text"></td>
            </tr>
            <tr align="left">
             <td>UDP Port</td>
             <td><input name="DEST_UDP_PORT" size="16" maxlength="15" value="$DEST_UDP_PORT" type="text"></td>
            </tr>
            <tr align="left">
             <td>ARQ Port</td>
             <td><input name="DEST_ARQ_PORT" size="16" maxlength="15" value="$DEST_ARQ_PORT" type="text"></td>
            </tr>
            <tr align="left">
             <td>TS packets per IP packet</td>
             <td><input name="NUM_TS_PKTS_PER_IP_PKT" size="16" maxlength="15" value="$NUM_TS_PKTS_PER_IP_PKT" type="text"></td>
            </tr>
            <tr>
              <td>Use Pacing</td>
              <td><input type=radio name="USE_PACING" value="1" $PACING1_CHECKED >Yes
                  <input type=radio name="USE_PACING" value="0" $PACING0_CHECKED >No
              </td>
            </tr>
            <!--
            <tr align="left">
             <td>Unicast TTL (Time-To-Live)</td>
             <td><input name="UNI_TTL" size="16" maxlength="15" value="$UNI_TTL" type="text"></td>
            </tr>
            <tr align="left">
             <td>Multicast TTL (Time-To-Live)</td>
             <td><input name="M_TTL" size="16" maxlength="15" value="$M_TTL" type="text"></td>
            </tr>
            <tr align="left">
             <td>TOS (Type-of-Service)</td>
             <td><input name="TOS" size="16" maxlength="15" value="$TOS" type="text"></td>
            </tr>
            -->
           </table>
         </div>
            
       </td>
     </tr>
   </table>

   <br>
   <input value="Save" type="submit">
 </form>
</body>
</html>
EOT

else
    eval `./cgiparse "$QUERY_STRING"`

    [ "$ROBUST" = "" ] && ROBUST=0

    msg="OK."

    cat << EOT > $CONF_FILE
PROGRAM=$PROGRAM
PROFILE=$PROFILE
LEVEL=$LEVEL
SRC_TRANSPORT=$SRC_TRANSPORT
SRC_MULTICAST_IPADDR=$SRC_MULTICAST_IPADDR
SRC_UDP_PORT=$SRC_UDP_PORT
NETWORK_JITTER=$NETWORK_JITTER
OUT_OF_ORDER_SIZE=$OUT_OF_ORDER_SIZE
RESPONSE=$RESPONSE
BURST_DROP=$BURST_DROP
ROBUST=$ROBUST
NUM_RETRIES=$NUM_RETRIES
RT_TIME=$RT_TIME
ARQ_MODE=$ARQ_MODE
ARQ_PORT=$ARQ_PORT
PING_SENDER=$PING_SENDER
SERVER_IPADDR=$SERVER_IPADDR
ECHO_PORT=$ECHO_PORT
MODE="$MODE"
DETECT_VIDEO_CHANGE=$DETECT_VIDEO_CHANGE
DETECT_VIDEO_MS=$DETECT_VIDEO_MS
VIDEO_ENCODING="$VIDEO_ENCODING"
VIDEO_RES=$VIDEO_RES
VIDEO_BITRATE=$VIDEO_BITRATE
AUDIO_ENCODING="$AUDIO_ENCODING"
DEST_TRANSPORT=$DEST_TRANSPORT
DEST_IPADDR_OR_HOSTNAME=$DEST_IPADDR_OR_HOSTNAME
DEST_UDP_PORT=$DEST_UDP_PORT
DEST_ARQ_PORT=$DEST_ARQ_PORT
NUM_TS_PKTS_PER_IP_PKT=$NUM_TS_PKTS_PER_IP_PKT
USE_PACING=$USE_PACING
UNI_TTL=$UNI_TTL
M_TTL=$M_TTL
TOS=$TOS
EOT

cat << EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <!-- Copyright 2004-2009 QVidium Technologies, Inc. All rights reserved. -->
  <title>Profile Status</title>
  <link href="/style.css" type="text/css" rel="stylesheet">
</head>
<body>
 <h2><center>Profile Status</center></h2>
 $msg <br><br>Press the "Profile" option to update view.
</body>
</html>
EOT

fi
