#!/bin/sh

# Copyright (C) 2004-2009 QVidium Technologies, Inc. All rights reserved.

# Print common header
cat << ENDHTML
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<LINK rel="stylesheet" href="/style.css" type="text/css">
<TITLE>Transcode Status</TITLE>
ENDHTML

pidof transcoder > /dev/null
if [ $? != 0 ] ; then
    cat << ENDHTML
</HEAD>
<BODY>
<P align="center"><STRONG>
<FONT size="5">Transcode Status</P>
<P align="left"></FONT></STRONG>
<strong><FONT size=4>Transcode is HALTED</font></strong>
<p>Not sending to network.</p>
</BODY>
</HTML>
ENDHTML
   exit 0
fi

STATUS_FILE=/var/run/Channel1.status
#[ ! -f $STATUS_FILE ] && STATUS_FILE=/var/run/net_in.status

# Read in current stats from *.status in /var/run
if [ -f $STATUS_FILE ] ; then

    if [ "$QUERY_STRING" != "" ] ; then
        cat << ENDHTML
<SCRIPT LANGUAGE=JAVASCRIPT>

  function RefreshPage()
  {
     window.location.reload(true);
  }

  function StartTimer()
  {
     window.setTimeout("RefreshPage()", 3000);
  }

</SCRIPT>
</HEAD>
<BODY onload="StartTimer();">
ENDHTML
    else
        cat << ENDHTML
</HEAD>
<BODY>
ENDHTML
    fi
    cat << ENDHTML
<P align="center"><STRONG>
<FONT size="5">Transcode Status</P>
<P align="left"></FONT></STRONG>
ENDHTML

    NET_BITRATE=0
    RCV_IPADDR=nodata
    RCV_PORT=0
    SRC_MULTICAST_IPADDR=
    JITTER=0
    NET_LOSS=0
    RECONSTRUCTED=0
    RECON_ROW=0
    RECON_COL=0
    UNRECOVERED=0
    LOST_PARITY=0
    OUT_OF_ORDER=0
    DUPLICATE=0
    JITTER_SEEN=0
    ROWS=0
    COL=0
    ROW_FEC_ON=0
    PKT_LEN=0

    NET_DROPPED=0
    NET_BURSTLOSS=0
    NET_JITTER=0
    NET_OUTOFORDER=0
    NET_OUTOFORDERSTALE=0
    NET_DUPLICATES=0
    NET_TOTAL_PACKETS=0
    ARQ_DROPPED=0
    ARQ_RECOVERED=0
    ARQ_RESENT=0
    ARQ_DUPLICATE=0
    ARQ_MAXBURSTLOSSMS=0
    ARQ_RT_TIME=0
    ARQ_NUM_RETRIES=0
    ARQ_JITTER=0

    SRC_TRANSPORT=UDP
    [ -f /var/run/net_in_out.conf ] && . /var/run/net_in_out.conf

    eval `grep '[A-Z].*=' $STATUS_FILE`
    #. $STATUS_FILE 2> /dev/null

    #[ "$SRC_MULTICAST_IPADDR" = "" ] && SRC_MULTICAST_IPADDR="(Not Set)"

    RowFEC="Off"
    [ "$ROW_FEC_ON" = 1 ] && RowFEC="On"

    STARTED=`cat /var/log/net_in_out.start`
    STATS_CLEARED=`cat /var/log/net_in_out.stats`
    
    echo "Current Time: "
    date -R
    echo "<br>"
    
cat << ENDHTML
   <TABLE class=props cellSpacing="1" cellPadding="2" border="1">
     <tr align=center><td colSpan="2" nowrap><strong><font size="4">Stream</font></strong></td></tr>
     <TR><TD width="190">Started:</TD><TD width="300">$STARTED</TD></TR>
     <TR><TD width="190">Stats Cleared:</TD><TD width="300">$STATS_CLEARED</TD></TR>
ENDHTML
if [ "$MODE" = "ASI to IP" ] ; then
echo "     <TR><TD width="190">Mode:</TD><TD width="300">$MODE</TD></TR>"
else
cat << ENDHTML
     <tr align=center><td colSpan="2" nowrap><strong><font size="4">Network Receive</font></strong></td></tr>
     <TR><TD width="190">Transport:</TD><TD width="300">$SRC_TRANSPORT</TD></TR>
     <TR><TD width="190">Bitrate:</TD><TD width="300">$NET_BITRATE</TD></TR>
     <TR><TD width="190">Sender:</TD><TD width="300">$RCV_IPADDR</TD></TR>
     <TR><TD width="190">UDP Port:</TD><TD width="300">$RCV_PORT</TD></TR>
ENDHTML
    if [ "$SRC_MULTICAST_IPADDR" != "" ] ; then
        cat << ENDHTML
     <TR><TD width="190">Multicast Addr:</TD><TD width="300">$SRC_MULTICAST_IPADDR</TD></TR>
ENDHTML
    fi
    if [ "$SRC_TRANSPORT" = UDP ] ; then
        cat << ENDHTML
     <TR><TD width="190">Total Packets:</TD><TD width="300">$NET_TOTAL_PACKETS</TD></TR>
ENDHTML
    fi
    if [ "$SRC_TRANSPORT" != UDP ] ; then
     if [ "$SRC_TRANSPORT" = ARQ ] ; then
cat << ENDHTML
     <TR><TD width="190">Packet loss:</TD><TD width="300">$NET_LOSS</TD></TR>
     <TR><TD width="190">Burst loss:</TD><TD width="300">$NET_BURSTLOSS</TD></TR>
     <TR><TD width="190">Jitter:</TD><TD width="300">$NET_JITTER</TD></TR>
     <TR><TD width="190">Out of Order:</TD><TD width="300">$NET_OUTOFORDER</TD></TR>
     <TR><TD width="190">Duplicates:</TD><TD width="300">$NET_DUPLICATES</TD></TR>
     <TR><TD width="190">Out of Order Stale:</TD><TD width="300">$NET_OUTOFORDERSTALE</TD></TR>
     <TR><TD width="190">Total Out of Order:</TD><TD width="300">$NET_OUTOFORDER</TD></TR>
     <TR><TD width="190">Max Out of Order:</TD><TD width="300">$NET_OUTOFORDERMAX</TD></TR>
     <TR><TD width="190">Packet Len:</TD><TD width="300">$PKT_LEN</TD></TR>
     <TR><TD width="190">Total Packets:</TD><TD width="300">$NET_TOTAL_PACKETS</TD></TR>
     <tr align=center><td colSpan="2" nowrap><strong><font size="4">ARQ Receive</font></strong></td></tr>
     <TR><TD width="190">Unrecovered:</TD><TD width="300">$ARQ_DROPPED</TD></TR>
     <TR><TD width="190">Total recovered:</TD><TD width="300">$ARQ_RECOVERED</TD></TR>
     <TR><TD width="190">Resent:</TD><TD width="300">$ARQ_RESENT</TD></TR>
     <TR><TD width="190">Duplicates:</TD><TD width="300">$ARQ_DUPLICATE</TD></TR>
     <TR><TD width="190">Max burst loss:</TD><TD width="300">$ARQ_MAXBURSTLOSSMS ms</TD></TR>
     <TR><TD width="190">Max Burst Loss (pkts):</TD><TD width="300">$ARQ_MAXBURSTLOSS</TD></TR>
     <TR><TD width="190">Measured RT Time:</TD><TD width="300">$ARQ_RT_TIME ms</TD></TR>
     <TR><TD width="190">Retries (computed):</TD><TD width="300">$ARQ_NUM_RETRIES</TD></TR>
     <TR><TD width="190">Jitter Buffer:</TD><TD width="300">$ARQ_JITTER ms</TD></TR>
     <TR><TD width="190">Port:</TD><TD width="300">$ARQ_PORT</TD></TR>
ENDHTML
     else # SRC_TRANSPORT != ARQ
cat << ENDHTML
      <TR><TD width="190">Packet loss:</TD><TD width="300">$NET_LOSS</TD></TR>
      <TR><TD width="190">Jitter:</TD><TD width="300">$JITTER_SEEN</TD></TR>
      <TR><TD width="190">Out of order:</TD><TD width="300">$OUT_OF_ORDER</TD></TR>
      <TR><TD width="190">Duplicates:</TD><TD width="300">$DUPLICATE</TD></TR>
      <TR><TD width="190">Packet Len:</TD><TD width="300">$PKT_LEN</TD></TR>
      <TR><TD width="190">Total Packets:</TD><TD width="300">$NET_TOTAL_PACKETS</TD></TR>
ENDHTML
      if [ "$SRC_TRANSPORT" = ProMPEG ] ; then
cat << ENDHTML
       <tr align=center><td colSpan="2" nowrap><strong><font size="4">FEC Receive</font></strong></td></tr>
       <TR><TD width="190">Unrecovered:</TD><TD width="300">$UNRECOVERED</TD></TR>
       <TR><TD width="190">Total recovered:</TD><TD width="300">$RECONSTRUCTED</TD></TR>
       <TR><TD width="190">&nbsp;&nbsp;Row recovered:</TD><TD width="300">$RECON_ROW</TD></TR>
       <TR><TD width="190">&nbsp;&nbsp;Column recovered:</TD><TD width="300">$RECON_COL</TD></TR>
       <TR><TD width="190">Rows:</TD><TD width="300">$ROWS</TD></TR>
       <TR><TD width="190">Columns:</TD><TD width="300">$COL</TD></TR>
       <TR><TD width="190">Row FEC:</TD><TD width="300">$RowFEC</TD></TR>
ENDHTML
      fi # SRC_TRANSPORT = ProMPEG
     fi # SRC_TRANSPORT = ARQ
    fi # SRC_TRANSPORT != UDP
  fi
   
    echo "   </TABLE>"
fi

STATUS_FILE=/var/run/net_out1.status
if [ "$MODE" = "IP to ASI" ] ; then
    cat << ENDHTML
   <p>
   <TABLE class=props cellSpacing="1" cellPadding="2" border="1">
     <tr align=center><td colSpan="2" nowrap><strong><font size="4">Output</font></strong></td></tr>
     <TR><TD width="190">Mode:</TD><TD width="300">$MODE</TD></TR>
   </TABLE>
ENDHTML
elif [ -f $STATUS_FILE ] ; then
   # Read in current stats from *.status in /var/run

    DEST_TRANSPORT=UDP
    if [ -f /flash/qvidium/transcode/profile ] ; then
        . /flash/qvidium/transcode/profile
    fi

    eval `grep '[A-Z].*=' $STATUS_FILE`
    #. $STATUS_FILE 2> /dev/null

    cat << ENDHTML
   <p>
   <TABLE class=props cellSpacing="1" cellPadding="2" border="1">
     <tr align=center><td colSpan="2" nowrap><strong><font size="4">Network Send</font></strong></td></tr>
     <TR><TD width="190">Transport:</TD><TD width="300">$DEST_TRANSPORT</TD></TR>
     <TR><TD width="190">Bitrate:</TD><TD width="300">$NET_BITRATE</TD></TR>
     <TR><TD width="190">Total Packets:</TD><TD width="300">$NET_TOTAL_PACKETS</TD></TR>
ENDHTML
    if [ "$DEST_TRANSPORT" = ARQx ] ; then
        cat << ENDHTML
      <tr align=center><td colSpan="2" nowrap><strong><font size="4">ARQ Send</font></strong></td></tr>
      <TR><TD width="190">Resent:</TD><TD width="300">$ARQ_RESENT</TD></TR>
      <TR><TD width="190">Missing:</TD><TD width="300">$ARQ_MISS</TD></TR>
      <TR><TD width="190">Max Burst Loss:</TD><TD width="300">$ARQ_MAXBURSTLOSS</TD></TR>
      <TR><TD width="190">Stale Requests:</TD><TD width="300">$ARQ_STALE</TD></TR>
      <TR><TD width="190">Ignored Requests:</TD><TD width="300">$ARQ_IGNORED</TD></TR>
      <TR><TD width="190">Delay:</TD><TD width="300">$ARQ_DELAY</TD></TR>
      <TR><TD width="190">Number Retries:</TD><TD width="300">$ARQ_NUM_RETRIES</TD></TR>
      <TR><TD width="190">Round Trip Time:</TD><TD width="300">$ARQ_RTT</TD></TR>
ENDHTML
    fi
   
    echo "   </TABLE>"

else
    cat << ENDHTML
</HEAD>
<BODY>
<P align="center"><STRONG>
<FONT size="5">Transcode Status</P>
<P align="left"></FONT></STRONG>
<p><FONT size=4>No network stats available.</P>
ENDHTML
fi

cat << ENDHTML
</BODY>
</HTML>
ENDHTML

exit 0
